/****************************************************************************
** Generated from 'Example.IVI.Remote.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#include "processingservicebackend.h"

#include <QDebug>
#include <QSettings>
#include <QTimer>
#include "remotemodule.h"

Q_LOGGING_CATEGORY(qLcROProcessingService, "example.ivi.remote.processingservicebackend.remoteobjects", QtInfoMsg)


QT_BEGIN_NAMESPACE


ProcessingServiceBackend::ProcessingServiceBackend(const QString &remoteObjectsLookupName, QObject *parent)
    : ProcessingServiceBackendInterface(parent)
    , m_node(nullptr)
    , m_remoteObjectsLookupName(remoteObjectsLookupName)
    , m_helper(new QIviRemoteObjectReplicaHelper(qLcROProcessingService(), this))
{
    RemoteModule::registerTypes();

}

ProcessingServiceBackend::~ProcessingServiceBackend()
{
    delete m_node;
}

void ProcessingServiceBackend::initialize()
{

    if (!connectToNode())
        return;

    if (m_replica->isInitialized()) {
        Q_EMIT lastMessageChanged(m_replica->lastMessage());
        Q_EMIT initializationDone();
    }

    QTimer::singleShot(3000, this, [this](){
        if(!m_replica->isInitialized())
            qCCritical(qLcROProcessingService) << "Example.IVI.Remote.ProcessingService wasn't initialized within the timeout period. Please make sure the server is running.";
    });
}


void ProcessingServiceBackend::setLastMessage(const QString &lastMessage)
{
    if (m_replica.isNull())
        return;
    m_replica->pushLastMessage(lastMessage);
}


QIviPendingReply<int> ProcessingServiceBackend::process(const QString &data)
{
    if (m_replica.isNull())
        return QIviPendingReply<int>::createFailedReply();
    else if (static_cast<QRemoteObjectReplica*>(m_replica.get())->state() != QRemoteObjectReplica::Valid)
        return QIviPendingReply<int>::createFailedReply();

    qCDebug(qLcROProcessingService) << "process called";
    QRemoteObjectPendingReply<QVariant> reply = m_replica->process(data);
    auto iviReply = m_helper->toQIviPendingReply<int>(reply);

    //Pass an empty std::function to only handle errors.
    iviReply.then(std::function<void(int)>(), [this]() {
        Q_EMIT errorChanged(QIviAbstractFeature::InvalidOperation, QStringLiteral("ProcessingServiceBackend, remote call of method process failed"));
    });
    return iviReply;
}


bool ProcessingServiceBackend::connectToNode()
{
    static QString configPath;
    if (configPath.isEmpty()) {
        if (qEnvironmentVariableIsSet("SERVER_CONF_PATH")) {
            configPath = QString::fromLocal8Bit(qgetenv("SERVER_CONF_PATH"));
        } else {
            configPath = QStringLiteral("./server.conf");
            qCInfo(qLcROProcessingService) << "Environment variable SERVER_CONF_PATH not defined, using " << configPath;
        }
    }

    QSettings settings(configPath, QSettings::IniFormat);
    settings.beginGroup(QStringLiteral("remote"));
    QUrl registryUrl = QUrl(settings.value(QStringLiteral("Registry"), QStringLiteral("local:remote")).toString());
    if (m_url != registryUrl) {
        m_url = registryUrl;
        // QtRO doesn't allow to change the URL without destroying the Node
        delete m_node;
        m_node = new QRemoteObjectNode();
        if (!m_node->connectToNode(m_url)) {
            qCCritical(qLcROProcessingService) << "Connection to" << m_url << "failed!";
            m_replica.reset();
            return false;
        }
        qCInfo(qLcROProcessingService) << "Connecting to" << m_url;
        m_replica.reset(m_node->acquire<ProcessingServiceReplica>(m_remoteObjectsLookupName));
        setupConnections();
    }
    return true;
}

void ProcessingServiceBackend::setupConnections()
{
    connect(m_node, &QRemoteObjectNode::error, m_helper, &QIviRemoteObjectReplicaHelper::onNodeError);
    connect(m_helper, &QIviRemoteObjectReplicaHelper::errorChanged, this, &QIviFeatureInterface::errorChanged);

    connect(m_replica.data(), &QRemoteObjectReplica::stateChanged, m_helper, &QIviRemoteObjectReplicaHelper::onReplicaStateChanged);
    connect(m_replica.data(), &ProcessingServiceReplica::pendingResultAvailable, m_helper, &QIviRemoteObjectReplicaHelper::onPendingResultAvailable);
    //As the Replica is now initialized, this will trigger an update of all properties (not just the changed ones)
    connect(m_replica.data(), &QRemoteObjectReplica::initialized, this, &ProcessingServiceBackend::initialize);
    connect(m_replica.data(), &ProcessingServiceReplica::lastMessageChanged, this, &ProcessingServiceBackend::lastMessageChanged);
}


QT_END_NAMESPACE
