#ifndef REP_PROCESSINGSERVICE_SOURCE_H
#define REP_PROCESSINGSERVICE_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include "remotemodule.h"

class ProcessingServiceSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "ProcessingService")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "bae940f5d6c5435d80c8bc6fbca74b9a3e9d76e2")
    Q_PROPERTY(QString lastMessage READ lastMessage WRITE setLastMessage NOTIFY lastMessageChanged)

public:
    explicit ProcessingServiceSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~ProcessingServiceSource() override = default;

    virtual QString lastMessage() const = 0;
    virtual void setLastMessage(QString lastMessage) = 0;

Q_SIGNALS:
    void lastMessageChanged(QString lastMessage);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual void pushLastMessage(QString lastMessage)
    {
        setLastMessage(lastMessage);
    }
    virtual QVariant process(const QString & data) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class ProcessingServiceSimpleSource : public ProcessingServiceSource
{
    Q_OBJECT

public:
    explicit ProcessingServiceSimpleSource(QObject *parent = nullptr) : ProcessingServiceSource(parent)
    , m_lastMessage()
    {
    }

public:
    ~ProcessingServiceSimpleSource() override = default;

    QString lastMessage() const override { return m_lastMessage; }
    void setLastMessage(QString lastMessage) override
    {
        if (lastMessage != m_lastMessage) {
            m_lastMessage = lastMessage;
            Q_EMIT lastMessageChanged(m_lastMessage);
        }
    }

private:
    QString m_lastMessage;
};


template <class ObjectType>
struct ProcessingServiceSourceAPI : public SourceApiMap
{
    ProcessingServiceSourceAPI(ObjectType *object, const QString &name = QLatin1String("ProcessingService"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::lastMessage, static_cast<QString (QObject::*)()>(0),"lastMessage");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::lastMessageChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 2;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::lastMessageChanged, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushLastMessage, static_cast<void (QObject::*)(QString)>(0),"pushLastMessage(QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::process, static_cast<void (QObject::*)(QString)>(0),"process(QString)",m_methodArgCount+1,&m_methodArgTypes[1]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("ProcessingService"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("lastMessageChanged(QString)");
        case 1: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushLastMessage(QString)");
        case 1: return QByteArrayLiteral("process(QString)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("QVariant");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"bae940f5d6c5435d80c8bc6fbca74b9a3e9d76e2"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[3];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[2];
    const int* m_signalArgTypes[2];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_PROCESSINGSERVICE_SOURCE_H
