/****************************************************************************
** Generated from 'QtIviVehicleFunctions.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/


#include "qiviclimatecontrol.h"
#include "qiviclimatecontrol_p.h"
#include "qiviclimatecontrolbackendinterface.h"

#include <QQmlEngine>
#include <QIviServiceObject>
#include <QIviProxyServiceObject>

QT_BEGIN_NAMESPACE

/*!
    \class QIviClimateControl
    \inmodule QtIviVehicleFunctions

    \brief Provides an interface to the climate control.
    
    The QIviClimateControl provides an interface to the climate control of the vehicle.
    
    The climate control properties are divided into two categories: central or zoned. The central
    properties are exposed directly through the QIviClimateControl and the zoned properties are
    exposed through zone objects. The zones are retrieved using the \l {QIviAbstractZonedFeature::}{zoneAt} method.
    
    The QIviClimateControl expects a single backend to be available. It is recommended to use it
    with \l {QIviAbstractFeature::}{discoveryMode} set to \l {QIviAbstractFeature::}{AutoDiscovery}.
    

*/

/*!
    \qmltype ClimateControl
    \instantiates QIviClimateControl
    \inqmlmodule QtIvi.VehicleFunctions
    \inherits AbstractZonedFeature


    \brief Provides an interface to the climate control.
    
    The QIviClimateControl provides an interface to the climate control of the vehicle.
    
    The climate control properties are divided into two categories: central or zoned. The central
    properties are exposed directly through the QIviClimateControl and the zoned properties are
    exposed through zone objects. The zones are retrieved using the \l {QIviAbstractZonedFeature::}{zoneAt} method.
    
    The QIviClimateControl expects a single backend to be available. It is recommended to use it
    with \l {QIviAbstractFeature::}{discoveryMode} set to \l {QIviAbstractFeature::}{AutoDiscovery}.
    

*/

/*! \internal */
QIviClimateControlPrivate::QIviClimateControlPrivate(const QString &interface, const QString &zone, QIviClimateControl *parent)
    : QIviAbstractZonedFeaturePrivate(interface, zone, parent)
    , q_ptr(parent)
    , m_airConditioningEnabled(bool(false))
    , m_heaterEnabled(bool(false))
    , m_fanSpeedLevel(int(0))
    , m_steeringWheelHeater(int(0))
    , m_targetTemperature(qreal(0.0))
    , m_seatCooler(int(0))
    , m_seatHeater(int(0))
    , m_outsideTemperature(int(0))
    , m_outsideTemperatureLabel(QString())
    , m_zoneSynchronizationEnabled(bool(false))
    , m_defrostEnabled(bool(false))
    , m_recirculationMode(QtIviVehicleFunctionsModule::RecirculationOff)
    , m_recirculationEnabled(bool(false))
    , m_recirculationSensitivityLevel(int(0))
    , m_climateMode(QtIviVehicleFunctionsModule::ClimateOff)
    , m_automaticClimateFanIntensityLevel(int(0))
    , m_airflowDirections(QtIviVehicleFunctionsModule::AirflowDirections())
{
    m_supportsPropertyOverriding = true;
}

/*! \internal */
QIviClimateControlPrivate *QIviClimateControlPrivate::get(QIviClimateControl *v)
{
    return reinterpret_cast<QIviClimateControlPrivate *>(v->d_ptr.data());
}

/*! \internal */
const QIviClimateControlPrivate *QIviClimateControlPrivate::get(const QIviClimateControl *v)
{
    return reinterpret_cast<const QIviClimateControlPrivate *>(v->d_ptr.data());
}

/*! \internal */
QIviClimateControl *QIviClimateControlPrivate::getParent()
{
    return q_ptr;
}

/*! \internal */
void QIviClimateControlPrivate::clearToDefaults()
{
    onAirConditioningEnabledChanged(bool(false), QString());
    onHeaterEnabledChanged(bool(false), QString());
    onFanSpeedLevelChanged(int(0), QString());
    onSteeringWheelHeaterChanged(int(0), QString());
    onTargetTemperatureChanged(qreal(0.0), QString());
    onSeatCoolerChanged(int(0), QString());
    onSeatHeaterChanged(int(0), QString());
    onOutsideTemperatureChanged(int(0), QString());
    onOutsideTemperatureLabelChanged(QString(), QString());
    onZoneSynchronizationEnabledChanged(bool(false), QString());
    onDefrostEnabledChanged(bool(false), QString());
    onRecirculationModeChanged(QtIviVehicleFunctionsModule::RecirculationOff, QString());
    onRecirculationEnabledChanged(bool(false), QString());
    onRecirculationSensitivityLevelChanged(int(0), QString());
    onClimateModeChanged(QtIviVehicleFunctionsModule::ClimateOff, QString());
    onAutomaticClimateFanIntensityLevelChanged(int(0), QString());
    onAirflowDirectionsChanged(QtIviVehicleFunctionsModule::AirflowDirections(), QString());
}

/*! \internal */
void QIviClimateControlPrivate::onAirConditioningEnabledChanged(bool airConditioningEnabled, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("airConditioningEnabled");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<bool>(airConditioningEnabled);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_airConditioningEnabled != airConditioningEnabled) {
        QIviClimateControlPrivate::get(f)->m_airConditioningEnabled = airConditioningEnabled;
        Q_EMIT f->airConditioningEnabledChanged(airConditioningEnabled);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onHeaterEnabledChanged(bool heaterEnabled, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("heaterEnabled");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<bool>(heaterEnabled);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_heaterEnabled != heaterEnabled) {
        QIviClimateControlPrivate::get(f)->m_heaterEnabled = heaterEnabled;
        Q_EMIT f->heaterEnabledChanged(heaterEnabled);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onFanSpeedLevelChanged(int fanSpeedLevel, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("fanSpeedLevel");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(fanSpeedLevel);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_fanSpeedLevel != fanSpeedLevel) {
        QIviClimateControlPrivate::get(f)->m_fanSpeedLevel = fanSpeedLevel;
        Q_EMIT f->fanSpeedLevelChanged(fanSpeedLevel);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onSteeringWheelHeaterChanged(int steeringWheelHeater, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("steeringWheelHeater");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(steeringWheelHeater);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_steeringWheelHeater != steeringWheelHeater) {
        QIviClimateControlPrivate::get(f)->m_steeringWheelHeater = steeringWheelHeater;
        Q_EMIT f->steeringWheelHeaterChanged(steeringWheelHeater);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onTargetTemperatureChanged(qreal targetTemperature, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("targetTemperature");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<qreal>(targetTemperature);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_targetTemperature != targetTemperature) {
        QIviClimateControlPrivate::get(f)->m_targetTemperature = targetTemperature;
        Q_EMIT f->targetTemperatureChanged(targetTemperature);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onSeatCoolerChanged(int seatCooler, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("seatCooler");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(seatCooler);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_seatCooler != seatCooler) {
        QIviClimateControlPrivate::get(f)->m_seatCooler = seatCooler;
        Q_EMIT f->seatCoolerChanged(seatCooler);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onSeatHeaterChanged(int seatHeater, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("seatHeater");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(seatHeater);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_seatHeater != seatHeater) {
        QIviClimateControlPrivate::get(f)->m_seatHeater = seatHeater;
        Q_EMIT f->seatHeaterChanged(seatHeater);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onOutsideTemperatureChanged(int outsideTemperature, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("outsideTemperature");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(outsideTemperature);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_outsideTemperature != outsideTemperature) {
        QIviClimateControlPrivate::get(f)->m_outsideTemperature = outsideTemperature;
        Q_EMIT f->outsideTemperatureChanged(outsideTemperature);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onOutsideTemperatureLabelChanged(const QString &outsideTemperatureLabel, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("outsideTemperatureLabel");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QString>(outsideTemperatureLabel);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_outsideTemperatureLabel != outsideTemperatureLabel) {
        QIviClimateControlPrivate::get(f)->m_outsideTemperatureLabel = outsideTemperatureLabel;
        Q_EMIT f->outsideTemperatureLabelChanged(outsideTemperatureLabel);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onZoneSynchronizationEnabledChanged(bool zoneSynchronizationEnabled, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("zoneSynchronizationEnabled");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<bool>(zoneSynchronizationEnabled);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_zoneSynchronizationEnabled != zoneSynchronizationEnabled) {
        QIviClimateControlPrivate::get(f)->m_zoneSynchronizationEnabled = zoneSynchronizationEnabled;
        Q_EMIT f->zoneSynchronizationEnabledChanged(zoneSynchronizationEnabled);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onDefrostEnabledChanged(bool defrostEnabled, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("defrostEnabled");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<bool>(defrostEnabled);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_defrostEnabled != defrostEnabled) {
        QIviClimateControlPrivate::get(f)->m_defrostEnabled = defrostEnabled;
        Q_EMIT f->defrostEnabledChanged(defrostEnabled);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onRecirculationModeChanged(QtIviVehicleFunctionsModule::RecirculationMode recirculationMode, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("recirculationMode");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::RecirculationMode>(recirculationMode);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_recirculationMode != recirculationMode) {
        QIviClimateControlPrivate::get(f)->m_recirculationMode = recirculationMode;
        Q_EMIT f->recirculationModeChanged(recirculationMode);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onRecirculationEnabledChanged(bool recirculationEnabled, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("recirculationEnabled");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<bool>(recirculationEnabled);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_recirculationEnabled != recirculationEnabled) {
        QIviClimateControlPrivate::get(f)->m_recirculationEnabled = recirculationEnabled;
        Q_EMIT f->recirculationEnabledChanged(recirculationEnabled);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onRecirculationSensitivityLevelChanged(int recirculationSensitivityLevel, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("recirculationSensitivityLevel");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(recirculationSensitivityLevel);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_recirculationSensitivityLevel != recirculationSensitivityLevel) {
        QIviClimateControlPrivate::get(f)->m_recirculationSensitivityLevel = recirculationSensitivityLevel;
        Q_EMIT f->recirculationSensitivityLevelChanged(recirculationSensitivityLevel);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onClimateModeChanged(QtIviVehicleFunctionsModule::ClimateMode climateMode, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("climateMode");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::ClimateMode>(climateMode);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_climateMode != climateMode) {
        QIviClimateControlPrivate::get(f)->m_climateMode = climateMode;
        Q_EMIT f->climateModeChanged(climateMode);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onAutomaticClimateFanIntensityLevelChanged(int automaticClimateFanIntensityLevel, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("automaticClimateFanIntensityLevel");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<int>(automaticClimateFanIntensityLevel);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_automaticClimateFanIntensityLevel != automaticClimateFanIntensityLevel) {
        QIviClimateControlPrivate::get(f)->m_automaticClimateFanIntensityLevel = automaticClimateFanIntensityLevel;
        Q_EMIT f->automaticClimateFanIntensityLevelChanged(automaticClimateFanIntensityLevel);
    }
}

/*! \internal */
void QIviClimateControlPrivate::onAirflowDirectionsChanged(QtIviVehicleFunctionsModule::AirflowDirections airflowDirections, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviClimateControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("airflowDirections");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::AirflowDirections>(airflowDirections);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviClimateControlPrivate::get(f)->m_airflowDirections != airflowDirections) {
        QIviClimateControlPrivate::get(f)->m_airflowDirections = airflowDirections;
        Q_EMIT f->airflowDirectionsChanged(airflowDirections);
    }
}


bool QIviClimateControlPrivate::notify(const QByteArray &propertyName, const QVariant &value)
{
    auto q = getParent();
    if (propertyName == QByteArray("airConditioningEnabled")) {
        Q_EMIT q->airConditioningEnabledChanged(value.value<bool>());
        return true;
    }
    if (propertyName == QByteArray("heaterEnabled")) {
        Q_EMIT q->heaterEnabledChanged(value.value<bool>());
        return true;
    }
    if (propertyName == QByteArray("fanSpeedLevel")) {
        Q_EMIT q->fanSpeedLevelChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("steeringWheelHeater")) {
        Q_EMIT q->steeringWheelHeaterChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("targetTemperature")) {
        Q_EMIT q->targetTemperatureChanged(value.value<qreal>());
        return true;
    }
    if (propertyName == QByteArray("seatCooler")) {
        Q_EMIT q->seatCoolerChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("seatHeater")) {
        Q_EMIT q->seatHeaterChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("outsideTemperature")) {
        Q_EMIT q->outsideTemperatureChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("outsideTemperatureLabel")) {
        Q_EMIT q->outsideTemperatureLabelChanged(value.value<QString>());
        return true;
    }
    if (propertyName == QByteArray("zoneSynchronizationEnabled")) {
        Q_EMIT q->zoneSynchronizationEnabledChanged(value.value<bool>());
        return true;
    }
    if (propertyName == QByteArray("defrostEnabled")) {
        Q_EMIT q->defrostEnabledChanged(value.value<bool>());
        return true;
    }
    if (propertyName == QByteArray("recirculationMode")) {
        Q_EMIT q->recirculationModeChanged(value.value<QtIviVehicleFunctionsModule::RecirculationMode>());
        return true;
    }
    if (propertyName == QByteArray("recirculationEnabled")) {
        Q_EMIT q->recirculationEnabledChanged(value.value<bool>());
        return true;
    }
    if (propertyName == QByteArray("recirculationSensitivityLevel")) {
        Q_EMIT q->recirculationSensitivityLevelChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("climateMode")) {
        Q_EMIT q->climateModeChanged(value.value<QtIviVehicleFunctionsModule::ClimateMode>());
        return true;
    }
    if (propertyName == QByteArray("automaticClimateFanIntensityLevel")) {
        Q_EMIT q->automaticClimateFanIntensityLevelChanged(value.value<int>());
        return true;
    }
    if (propertyName == QByteArray("airflowDirections")) {
        Q_EMIT q->airflowDirectionsChanged(value.value<QtIviVehicleFunctionsModule::AirflowDirections>());
        return true;
    }
    return QIviAbstractZonedFeaturePrivate::notify(propertyName, value);
}

/*!
   Default constructs an instance of QIviClimateControl to the given \a zone.

   If \a zone is not provided the General zone will be created.

   The \a parent argument is passed on to the \l QIviAbstractZonedFeature base class.
*/
QIviClimateControl::QIviClimateControl(const QString &zone, QObject *parent)
    : QIviAbstractZonedFeature(*new QIviClimateControlPrivate(QLatin1String(QtIviVehicleFunctions_QIviClimateControl_iid), zone, this), parent)
{
}

/*! \internal */
QIviClimateControl::~QIviClimateControl()
{
}

/*! \internal */
void QIviClimateControl::registerQmlTypes(const QString& uri, int majorVersion, int minorVersion)
{
    qmlRegisterType<QIviClimateControl>(uri.toLatin1(), majorVersion, minorVersion, "ClimateControl");
}


/*!
    \property QIviClimateControl::airConditioningEnabled

    Holds whether the air conditioning is enabled.
    

*/

/*!
    \qmlproperty bool ClimateControl::airConditioningEnabled

    Holds whether the air conditioning is enabled.
    


*/
bool QIviClimateControl::isAirConditioningEnabled() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("airConditioningEnabled")).value<bool>();
    return d->m_airConditioningEnabled;
}

void QIviClimateControl::setAirConditioningEnabled(bool airConditioningEnabled)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("airConditioningEnabled");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT airConditioningEnabledChanged(d->m_propertyOverride->property(pi).value<bool>());
            return;
        }
        forceUpdate = property("airConditioningEnabledDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("airConditioningEnabledDirtyOverride", {});
        QVariant v = QVariant::fromValue<bool>(airConditioningEnabled);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_airConditioningEnabled == airConditioningEnabled)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setAirConditioningEnabled(airConditioningEnabled, zone());
    else
        Q_EMIT airConditioningEnabledChanged(d->m_airConditioningEnabled);
}


/*!
    \property QIviClimateControl::heaterEnabled

    Indicates whether the heater is enabled.
    

*/

/*!
    \qmlproperty bool ClimateControl::heaterEnabled

    Indicates whether the heater is enabled.
    


*/
bool QIviClimateControl::isHeaterEnabled() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("heaterEnabled")).value<bool>();
    return d->m_heaterEnabled;
}

void QIviClimateControl::setHeaterEnabled(bool heaterEnabled)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("heaterEnabled");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT heaterEnabledChanged(d->m_propertyOverride->property(pi).value<bool>());
            return;
        }
        forceUpdate = property("heaterEnabledDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("heaterEnabledDirtyOverride", {});
        QVariant v = QVariant::fromValue<bool>(heaterEnabled);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_heaterEnabled == heaterEnabled)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setHeaterEnabled(heaterEnabled, zone());
    else
        Q_EMIT heaterEnabledChanged(d->m_heaterEnabled);
}


/*!
    \property QIviClimateControl::fanSpeedLevel

    Holds the fan speed level
    

*/

/*!
    \qmlproperty int ClimateControl::fanSpeedLevel

    Holds the fan speed level
    


*/
int QIviClimateControl::fanSpeedLevel() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("fanSpeedLevel")).value<int>();
    return d->m_fanSpeedLevel;
}

void QIviClimateControl::setFanSpeedLevel(int fanSpeedLevel)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("fanSpeedLevel");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT fanSpeedLevelChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("fanSpeedLevelDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("fanSpeedLevelDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(fanSpeedLevel);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_fanSpeedLevel == fanSpeedLevel)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setFanSpeedLevel(fanSpeedLevel, zone());
    else
        Q_EMIT fanSpeedLevelChanged(d->m_fanSpeedLevel);
}


/*!
    \property QIviClimateControl::steeringWheelHeater

    Holds the steering wheel heater level
    

*/

/*!
    \qmlproperty int ClimateControl::steeringWheelHeater

    Holds the steering wheel heater level
    


*/
int QIviClimateControl::steeringWheelHeater() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("steeringWheelHeater")).value<int>();
    return d->m_steeringWheelHeater;
}

void QIviClimateControl::setSteeringWheelHeater(int steeringWheelHeater)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("steeringWheelHeater");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT steeringWheelHeaterChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("steeringWheelHeaterDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("steeringWheelHeaterDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(steeringWheelHeater);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_steeringWheelHeater == steeringWheelHeater)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setSteeringWheelHeater(steeringWheelHeater, zone());
    else
        Q_EMIT steeringWheelHeaterChanged(d->m_steeringWheelHeater);
}


/*!
    \property QIviClimateControl::targetTemperature

    Holds the target temperature of the zone expressed
    in centigrades
    

*/

/*!
    \qmlproperty qreal ClimateControl::targetTemperature

    Holds the target temperature of the zone expressed
    in centigrades
    


*/
qreal QIviClimateControl::targetTemperature() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("targetTemperature")).value<qreal>();
    return d->m_targetTemperature;
}

void QIviClimateControl::setTargetTemperature(qreal targetTemperature)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("targetTemperature");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT targetTemperatureChanged(d->m_propertyOverride->property(pi).value<qreal>());
            return;
        }
        forceUpdate = property("targetTemperatureDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("targetTemperatureDirtyOverride", {});
        QVariant v = QVariant::fromValue<qreal>(targetTemperature);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_targetTemperature == targetTemperature)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setTargetTemperature(targetTemperature, zone());
    else
        Q_EMIT targetTemperatureChanged(d->m_targetTemperature);
}


/*!
    \property QIviClimateControl::seatCooler

    Holds the seat cooler level
    

*/

/*!
    \qmlproperty int ClimateControl::seatCooler

    Holds the seat cooler level
    


*/
int QIviClimateControl::seatCooler() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("seatCooler")).value<int>();
    return d->m_seatCooler;
}

void QIviClimateControl::setSeatCooler(int seatCooler)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("seatCooler");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT seatCoolerChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("seatCoolerDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("seatCoolerDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(seatCooler);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_seatCooler == seatCooler)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setSeatCooler(seatCooler, zone());
    else
        Q_EMIT seatCoolerChanged(d->m_seatCooler);
}


/*!
    \property QIviClimateControl::seatHeater

    Holds the seat heater level
    

*/

/*!
    \qmlproperty int ClimateControl::seatHeater

    Holds the seat heater level
    


*/
int QIviClimateControl::seatHeater() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("seatHeater")).value<int>();
    return d->m_seatHeater;
}

void QIviClimateControl::setSeatHeater(int seatHeater)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("seatHeater");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT seatHeaterChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("seatHeaterDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("seatHeaterDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(seatHeater);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_seatHeater == seatHeater)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setSeatHeater(seatHeater, zone());
    else
        Q_EMIT seatHeaterChanged(d->m_seatHeater);
}


/*!
    \property QIviClimateControl::outsideTemperature

    Holds the outside temperature of the zone expressed in
    centigrades
    

*/

/*!
    \qmlproperty int ClimateControl::outsideTemperature

    Holds the outside temperature of the zone expressed in
    centigrades
    


*/
int QIviClimateControl::outsideTemperature() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("outsideTemperature")).value<int>();
    return d->m_outsideTemperature;
}

void QIviClimateControl::setOutsideTemperature(int outsideTemperature)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("outsideTemperature");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT outsideTemperatureChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("outsideTemperatureDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("outsideTemperatureDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(outsideTemperature);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_outsideTemperature == outsideTemperature)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setOutsideTemperature(outsideTemperature, zone());
    else
        Q_EMIT outsideTemperatureChanged(d->m_outsideTemperature);
}


/*!
    \property QIviClimateControl::outsideTemperatureLabel

    The outside temperature expressed as a string, e.g. "mild"
    

*/

/*!
    \qmlproperty QString ClimateControl::outsideTemperatureLabel

    The outside temperature expressed as a string, e.g. "mild"
    


*/
QString QIviClimateControl::outsideTemperatureLabel() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("outsideTemperatureLabel")).value<QString>();
    return d->m_outsideTemperatureLabel;
}

void QIviClimateControl::setOutsideTemperatureLabel(const QString &outsideTemperatureLabel)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("outsideTemperatureLabel");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT outsideTemperatureLabelChanged(d->m_propertyOverride->property(pi).value<QString>());
            return;
        }
        forceUpdate = property("outsideTemperatureLabelDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("outsideTemperatureLabelDirtyOverride", {});
        QVariant v = QVariant::fromValue<QString>(outsideTemperatureLabel);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_outsideTemperatureLabel == outsideTemperatureLabel)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setOutsideTemperatureLabel(outsideTemperatureLabel, zone());
    else
        Q_EMIT outsideTemperatureLabelChanged(d->m_outsideTemperatureLabel);
}


/*!
    \property QIviClimateControl::zoneSynchronizationEnabled

    Indicates whether the zone synchronization is enabled.
    
    Which zones and properties are synchronized is controlled
    by the backend implementing it.
    

*/

/*!
    \qmlproperty bool ClimateControl::zoneSynchronizationEnabled

    Indicates whether the zone synchronization is enabled.
    
    Which zones and properties are synchronized is controlled
    by the backend implementing it.
    


*/
bool QIviClimateControl::isZoneSynchronizationEnabled() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("zoneSynchronizationEnabled")).value<bool>();
    return d->m_zoneSynchronizationEnabled;
}

void QIviClimateControl::setZoneSynchronizationEnabled(bool zoneSynchronizationEnabled)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("zoneSynchronizationEnabled");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT zoneSynchronizationEnabledChanged(d->m_propertyOverride->property(pi).value<bool>());
            return;
        }
        forceUpdate = property("zoneSynchronizationEnabledDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("zoneSynchronizationEnabledDirtyOverride", {});
        QVariant v = QVariant::fromValue<bool>(zoneSynchronizationEnabled);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_zoneSynchronizationEnabled == zoneSynchronizationEnabled)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setZoneSynchronizationEnabled(zoneSynchronizationEnabled, zone());
    else
        Q_EMIT zoneSynchronizationEnabledChanged(d->m_zoneSynchronizationEnabled);
}


/*!
    \property QIviClimateControl::defrostEnabled

    Indicates whether the defrost mode is enabled. Usually that means that the fans
    are on the highest level to remove ice from the windshield.
    

*/

/*!
    \qmlproperty bool ClimateControl::defrostEnabled

    Indicates whether the defrost mode is enabled. Usually that means that the fans
    are on the highest level to remove ice from the windshield.
    


*/
bool QIviClimateControl::isDefrostEnabled() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("defrostEnabled")).value<bool>();
    return d->m_defrostEnabled;
}

void QIviClimateControl::setDefrostEnabled(bool defrostEnabled)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("defrostEnabled");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT defrostEnabledChanged(d->m_propertyOverride->property(pi).value<bool>());
            return;
        }
        forceUpdate = property("defrostEnabledDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("defrostEnabledDirtyOverride", {});
        QVariant v = QVariant::fromValue<bool>(defrostEnabled);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_defrostEnabled == defrostEnabled)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setDefrostEnabled(defrostEnabled, zone());
    else
        Q_EMIT defrostEnabledChanged(d->m_defrostEnabled);
}


/*!
    \property QIviClimateControl::recirculationMode

    Holds the current recirculation mode
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::RecirculationMode ClimateControl::recirculationMode

    Holds the current recirculation mode
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc RecirculationMode
*/
QtIviVehicleFunctionsModule::RecirculationMode QIviClimateControl::recirculationMode() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("recirculationMode")).value<QtIviVehicleFunctionsModule::RecirculationMode>();
    return d->m_recirculationMode;
}

void QIviClimateControl::setRecirculationMode(QtIviVehicleFunctionsModule::RecirculationMode recirculationMode)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("recirculationMode");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT recirculationModeChanged(d->m_propertyOverride->property(pi).value<QtIviVehicleFunctionsModule::RecirculationMode>());
            return;
        }
        forceUpdate = property("recirculationModeDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("recirculationModeDirtyOverride", {});
        QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::RecirculationMode>(recirculationMode);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_recirculationMode == recirculationMode)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setRecirculationMode(recirculationMode, zone());
    else
        Q_EMIT recirculationModeChanged(d->m_recirculationMode);
}


/*!
    \property QIviClimateControl::recirculationEnabled

    Indicates whether the recirculation is currently running.
    

*/

/*!
    \qmlproperty bool ClimateControl::recirculationEnabled

    Indicates whether the recirculation is currently running.
    


*/
bool QIviClimateControl::isRecirculationEnabled() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("recirculationEnabled")).value<bool>();
    return d->m_recirculationEnabled;
}

void QIviClimateControl::setRecirculationEnabled(bool recirculationEnabled)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("recirculationEnabled");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT recirculationEnabledChanged(d->m_propertyOverride->property(pi).value<bool>());
            return;
        }
        forceUpdate = property("recirculationEnabledDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("recirculationEnabledDirtyOverride", {});
        QVariant v = QVariant::fromValue<bool>(recirculationEnabled);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_recirculationEnabled == recirculationEnabled)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setRecirculationEnabled(recirculationEnabled, zone());
    else
        Q_EMIT recirculationEnabledChanged(d->m_recirculationEnabled);
}


/*!
    \property QIviClimateControl::recirculationSensitivityLevel

    Holds the sensitivity level of the recirculation
    system when the recirculationMode is set to AutoRecirculation.
    

*/

/*!
    \qmlproperty int ClimateControl::recirculationSensitivityLevel

    Holds the sensitivity level of the recirculation
    system when the recirculationMode is set to AutoRecirculation.
    


*/
int QIviClimateControl::recirculationSensitivityLevel() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("recirculationSensitivityLevel")).value<int>();
    return d->m_recirculationSensitivityLevel;
}

void QIviClimateControl::setRecirculationSensitivityLevel(int recirculationSensitivityLevel)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("recirculationSensitivityLevel");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT recirculationSensitivityLevelChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("recirculationSensitivityLevelDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("recirculationSensitivityLevelDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(recirculationSensitivityLevel);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_recirculationSensitivityLevel == recirculationSensitivityLevel)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setRecirculationSensitivityLevel(recirculationSensitivityLevel, zone());
    else
        Q_EMIT recirculationSensitivityLevelChanged(d->m_recirculationSensitivityLevel);
}


/*!
    \property QIviClimateControl::climateMode

    value holds the climate mode
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::ClimateMode ClimateControl::climateMode

    value holds the climate mode
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc ClimateMode
*/
QtIviVehicleFunctionsModule::ClimateMode QIviClimateControl::climateMode() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("climateMode")).value<QtIviVehicleFunctionsModule::ClimateMode>();
    return d->m_climateMode;
}

void QIviClimateControl::setClimateMode(QtIviVehicleFunctionsModule::ClimateMode climateMode)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("climateMode");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT climateModeChanged(d->m_propertyOverride->property(pi).value<QtIviVehicleFunctionsModule::ClimateMode>());
            return;
        }
        forceUpdate = property("climateModeDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("climateModeDirtyOverride", {});
        QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::ClimateMode>(climateMode);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_climateMode == climateMode)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setClimateMode(climateMode, zone());
    else
        Q_EMIT climateModeChanged(d->m_climateMode);
}


/*!
    \property QIviClimateControl::automaticClimateFanIntensityLevel

    Holds the intensity level of the fan when the climateMode
    is set to AutoClimate.
    

*/

/*!
    \qmlproperty int ClimateControl::automaticClimateFanIntensityLevel

    Holds the intensity level of the fan when the climateMode
    is set to AutoClimate.
    


*/
int QIviClimateControl::automaticClimateFanIntensityLevel() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("automaticClimateFanIntensityLevel")).value<int>();
    return d->m_automaticClimateFanIntensityLevel;
}

void QIviClimateControl::setAutomaticClimateFanIntensityLevel(int automaticClimateFanIntensityLevel)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("automaticClimateFanIntensityLevel");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT automaticClimateFanIntensityLevelChanged(d->m_propertyOverride->property(pi).value<int>());
            return;
        }
        forceUpdate = property("automaticClimateFanIntensityLevelDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("automaticClimateFanIntensityLevelDirtyOverride", {});
        QVariant v = QVariant::fromValue<int>(automaticClimateFanIntensityLevel);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_automaticClimateFanIntensityLevel == automaticClimateFanIntensityLevel)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setAutomaticClimateFanIntensityLevel(automaticClimateFanIntensityLevel, zone());
    else
        Q_EMIT automaticClimateFanIntensityLevelChanged(d->m_automaticClimateFanIntensityLevel);
}


/*!
    \property QIviClimateControl::airflowDirections

    Holds the combination of flags indicating the areas
    where airflow is on.
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::AirflowDirections ClimateControl::airflowDirections

    Holds the combination of flags indicating the areas
    where airflow is on.
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc AirflowDirection
*/
QtIviVehicleFunctionsModule::AirflowDirections QIviClimateControl::airflowDirections() const
{
    const auto d = QIviClimateControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("airflowDirections")).value<QtIviVehicleFunctionsModule::AirflowDirections>();
    return d->m_airflowDirections;
}

void QIviClimateControl::setAirflowDirections(QtIviVehicleFunctionsModule::AirflowDirections airflowDirections)
{
    auto d = QIviClimateControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("airflowDirections");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT airflowDirectionsChanged(d->m_propertyOverride->property(pi).value<QtIviVehicleFunctionsModule::AirflowDirections>());
            return;
        }
        forceUpdate = property("airflowDirectionsDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("airflowDirectionsDirtyOverride", {});
        QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::AirflowDirections>(airflowDirections);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_airflowDirections == airflowDirections)
        return;
    if (QIviClimateControlBackendInterface *backend = qiviclimatecontrolBackend())
        backend->setAirflowDirections(airflowDirections, zone());
    else
        Q_EMIT airflowDirectionsChanged(d->m_airflowDirections);
}


/*! \internal */
QIviAbstractZonedFeature *QIviClimateControl::createZoneFeature(const QString &zone)
{
    return new QIviClimateControl(zone, this);
}

/*! \internal */
void QIviClimateControl::connectToServiceObject(QIviServiceObject *serviceObject)
{
    auto d = QIviClimateControlPrivate::get(this);

    auto *backend = qiviclimatecontrolBackend();
    if (!backend)
        return;

    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::airConditioningEnabledChanged,
        d, &QIviClimateControlPrivate::onAirConditioningEnabledChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::heaterEnabledChanged,
        d, &QIviClimateControlPrivate::onHeaterEnabledChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::fanSpeedLevelChanged,
        d, &QIviClimateControlPrivate::onFanSpeedLevelChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::steeringWheelHeaterChanged,
        d, &QIviClimateControlPrivate::onSteeringWheelHeaterChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::targetTemperatureChanged,
        d, &QIviClimateControlPrivate::onTargetTemperatureChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::seatCoolerChanged,
        d, &QIviClimateControlPrivate::onSeatCoolerChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::seatHeaterChanged,
        d, &QIviClimateControlPrivate::onSeatHeaterChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::outsideTemperatureChanged,
        d, &QIviClimateControlPrivate::onOutsideTemperatureChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::outsideTemperatureLabelChanged,
        d, &QIviClimateControlPrivate::onOutsideTemperatureLabelChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::zoneSynchronizationEnabledChanged,
        d, &QIviClimateControlPrivate::onZoneSynchronizationEnabledChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::defrostEnabledChanged,
        d, &QIviClimateControlPrivate::onDefrostEnabledChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::recirculationModeChanged,
        d, &QIviClimateControlPrivate::onRecirculationModeChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::recirculationEnabledChanged,
        d, &QIviClimateControlPrivate::onRecirculationEnabledChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::recirculationSensitivityLevelChanged,
        d, &QIviClimateControlPrivate::onRecirculationSensitivityLevelChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::climateModeChanged,
        d, &QIviClimateControlPrivate::onClimateModeChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::automaticClimateFanIntensityLevelChanged,
        d, &QIviClimateControlPrivate::onAutomaticClimateFanIntensityLevelChanged);
    QObjectPrivate::connect(backend, &QIviClimateControlBackendInterface::airflowDirectionsChanged,
        d, &QIviClimateControlPrivate::onAirflowDirectionsChanged);

    QIviAbstractZonedFeature::connectToServiceObject(serviceObject);
}

/*! \internal */
void QIviClimateControl::clearServiceObject()
{
    auto d = QIviClimateControlPrivate::get(this);
    d->clearToDefaults();
    QIviAbstractZonedFeature::clearServiceObject();
}

/*! \internal */
QIviClimateControlBackendInterface *QIviClimateControl::qiviclimatecontrolBackend() const
{
    return qivi_interface_cast<QIviClimateControlBackendInterface*>(backend());
}

QT_END_NAMESPACE

#include "moc_qiviclimatecontrol.cpp"
