/****************************************************************************
** Generated from 'QtIviVehicleFunctions.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/


#include "qiviwindowcontrol.h"
#include "qiviwindowcontrol_p.h"
#include "qiviwindowcontrolbackendinterface.h"

#include <QQmlEngine>
#include <QIviServiceObject>
#include <QIviProxyServiceObject>

QT_BEGIN_NAMESPACE

/*!
    \class QIviWindowControl
    \inmodule QtIviVehicleFunctions

    \brief Provides an interface to the window control.
    
    The QIviWindowControl provides an interface to control the physical windows of the vehicle.
    
    All properties are exposed through zone objects. The zones are retrieved using the \l {QIviAbstractZonedFeature::}{zoneAt} method.
    
    The QIviWindowControl expects a single backend to be available. It is recommended to use it
    with \l {QIviAbstractFeature::}{discoveryMode} set to \l {QIviAbstractZonedFeature::}{zoneAt}.
    

*/

/*!
    \qmltype WindowControl
    \instantiates QIviWindowControl
    \inqmlmodule QtIvi.VehicleFunctions
    \inherits AbstractZonedFeature


    \brief Provides an interface to the window control.
    
    The QIviWindowControl provides an interface to control the physical windows of the vehicle.
    
    All properties are exposed through zone objects. The zones are retrieved using the \l {QIviAbstractZonedFeature::}{zoneAt} method.
    
    The QIviWindowControl expects a single backend to be available. It is recommended to use it
    with \l {QIviAbstractFeature::}{discoveryMode} set to \l {QIviAbstractZonedFeature::}{zoneAt}.
    

*/

/*! \internal */
QIviWindowControlPrivate::QIviWindowControlPrivate(const QString &interface, const QString &zone, QIviWindowControl *parent)
    : QIviAbstractZonedFeaturePrivate(interface, zone, parent)
    , q_ptr(parent)
    , m_heaterMode(QtIviVehicleFunctionsModule::HeaterOn)
    , m_heater(bool(false))
    , m_state(QtIviVehicleFunctionsModule::FullyOpen)
    , m_blindMode(QtIviVehicleFunctionsModule::BlindOpen)
    , m_blindState(QtIviVehicleFunctionsModule::FullyOpen)
{
    m_supportsPropertyOverriding = true;
}

/*! \internal */
QIviWindowControlPrivate *QIviWindowControlPrivate::get(QIviWindowControl *v)
{
    return reinterpret_cast<QIviWindowControlPrivate *>(v->d_ptr.data());
}

/*! \internal */
const QIviWindowControlPrivate *QIviWindowControlPrivate::get(const QIviWindowControl *v)
{
    return reinterpret_cast<const QIviWindowControlPrivate *>(v->d_ptr.data());
}

/*! \internal */
QIviWindowControl *QIviWindowControlPrivate::getParent()
{
    return q_ptr;
}

/*! \internal */
void QIviWindowControlPrivate::clearToDefaults()
{
    onHeaterModeChanged(QtIviVehicleFunctionsModule::HeaterOn, QString());
    onHeaterChanged(bool(false), QString());
    onStateChanged(QtIviVehicleFunctionsModule::FullyOpen, QString());
    onBlindModeChanged(QtIviVehicleFunctionsModule::BlindOpen, QString());
    onBlindStateChanged(QtIviVehicleFunctionsModule::FullyOpen, QString());
}

/*! \internal */
void QIviWindowControlPrivate::onHeaterModeChanged(QtIviVehicleFunctionsModule::HeaterMode heaterMode, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviWindowControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("heaterMode");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::HeaterMode>(heaterMode);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviWindowControlPrivate::get(f)->m_heaterMode != heaterMode) {
        QIviWindowControlPrivate::get(f)->m_heaterMode = heaterMode;
        Q_EMIT f->heaterModeChanged(heaterMode);
    }
}

/*! \internal */
void QIviWindowControlPrivate::onHeaterChanged(bool heater, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviWindowControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("heater");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<bool>(heater);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviWindowControlPrivate::get(f)->m_heater != heater) {
        QIviWindowControlPrivate::get(f)->m_heater = heater;
        Q_EMIT f->heaterChanged(heater);
    }
}

/*! \internal */
void QIviWindowControlPrivate::onStateChanged(QtIviVehicleFunctionsModule::WindowState state, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviWindowControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("state");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::WindowState>(state);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviWindowControlPrivate::get(f)->m_state != state) {
        QIviWindowControlPrivate::get(f)->m_state = state;
        Q_EMIT f->stateChanged(state);
    }
}

/*! \internal */
void QIviWindowControlPrivate::onBlindModeChanged(QtIviVehicleFunctionsModule::BlindMode blindMode, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviWindowControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("blindMode");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::BlindMode>(blindMode);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviWindowControlPrivate::get(f)->m_blindMode != blindMode) {
        QIviWindowControlPrivate::get(f)->m_blindMode = blindMode;
        Q_EMIT f->blindModeChanged(blindMode);
    }
}

/*! \internal */
void QIviWindowControlPrivate::onBlindStateChanged(QtIviVehicleFunctionsModule::WindowState blindState, const QString &zone)
{
    auto q = getParent();
    auto f = qobject_cast<QIviWindowControl*>(q->zoneAt(zone));
    if (!f)
        f = q;
    if (f->zone() != zone)
        return;
    if (Q_UNLIKELY(m_propertyOverride)) {
        const int pi = f->metaObject()->indexOfProperty("blindState");
        if (m_propertyOverride->isOverridden(pi)) {
            QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::WindowState>(blindState);
            m_propertyOverride->setProperty(pi, v);
            return;
        }
    }
    if (QIviWindowControlPrivate::get(f)->m_blindState != blindState) {
        QIviWindowControlPrivate::get(f)->m_blindState = blindState;
        Q_EMIT f->blindStateChanged(blindState);
    }
}


bool QIviWindowControlPrivate::notify(const QByteArray &propertyName, const QVariant &value)
{
    auto q = getParent();
    if (propertyName == QByteArray("heaterMode")) {
        Q_EMIT q->heaterModeChanged(value.value<QtIviVehicleFunctionsModule::HeaterMode>());
        return true;
    }
    if (propertyName == QByteArray("heater")) {
        Q_EMIT q->heaterChanged(value.value<bool>());
        return true;
    }
    if (propertyName == QByteArray("state")) {
        Q_EMIT q->stateChanged(value.value<QtIviVehicleFunctionsModule::WindowState>());
        return true;
    }
    if (propertyName == QByteArray("blindMode")) {
        Q_EMIT q->blindModeChanged(value.value<QtIviVehicleFunctionsModule::BlindMode>());
        return true;
    }
    if (propertyName == QByteArray("blindState")) {
        Q_EMIT q->blindStateChanged(value.value<QtIviVehicleFunctionsModule::WindowState>());
        return true;
    }
    return QIviAbstractZonedFeaturePrivate::notify(propertyName, value);
}

/*!
   Default constructs an instance of QIviWindowControl to the given \a zone.

   If \a zone is not provided the General zone will be created.

   The \a parent argument is passed on to the \l QIviAbstractZonedFeature base class.
*/
QIviWindowControl::QIviWindowControl(const QString &zone, QObject *parent)
    : QIviAbstractZonedFeature(*new QIviWindowControlPrivate(QLatin1String(QtIviVehicleFunctions_QIviWindowControl_iid), zone, this), parent)
{
}

/*! \internal */
QIviWindowControl::~QIviWindowControl()
{
}

/*! \internal */
void QIviWindowControl::registerQmlTypes(const QString& uri, int majorVersion, int minorVersion)
{
    qmlRegisterType<QIviWindowControl>(uri.toLatin1(), majorVersion, minorVersion, "WindowControl");
}


/*!
    \property QIviWindowControl::heaterMode

    Holds the current mode of the window heater.
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::HeaterMode WindowControl::heaterMode

    Holds the current mode of the window heater.
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc HeaterMode
*/
QtIviVehicleFunctionsModule::HeaterMode QIviWindowControl::heaterMode() const
{
    const auto d = QIviWindowControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("heaterMode")).value<QtIviVehicleFunctionsModule::HeaterMode>();
    return d->m_heaterMode;
}

void QIviWindowControl::setHeaterMode(QtIviVehicleFunctionsModule::HeaterMode heaterMode)
{
    auto d = QIviWindowControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("heaterMode");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT heaterModeChanged(d->m_propertyOverride->property(pi).value<QtIviVehicleFunctionsModule::HeaterMode>());
            return;
        }
        forceUpdate = property("heaterModeDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("heaterModeDirtyOverride", {});
        QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::HeaterMode>(heaterMode);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_heaterMode == heaterMode)
        return;
    if (QIviWindowControlBackendInterface *backend = qiviwindowcontrolBackend())
        backend->setHeaterMode(heaterMode, zone());
    else
        Q_EMIT heaterModeChanged(d->m_heaterMode);
}


/*!
    \property QIviWindowControl::heater

    Indicates whether the window heater is currently running.
    

*/

/*!
    \qmlproperty bool WindowControl::heater

    Indicates whether the window heater is currently running.
    


*/
bool QIviWindowControl::heater() const
{
    const auto d = QIviWindowControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("heater")).value<bool>();
    return d->m_heater;
}


/*!
    \property QIviWindowControl::state

    Holds the current state of the window.
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::WindowState WindowControl::state

    Holds the current state of the window.
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc WindowState
*/
QtIviVehicleFunctionsModule::WindowState QIviWindowControl::state() const
{
    const auto d = QIviWindowControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("state")).value<QtIviVehicleFunctionsModule::WindowState>();
    return d->m_state;
}


/*!
    \property QIviWindowControl::blindMode

    Holds the current mode of the window blind.
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::BlindMode WindowControl::blindMode

    Holds the current mode of the window blind.
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc BlindMode
*/
QtIviVehicleFunctionsModule::BlindMode QIviWindowControl::blindMode() const
{
    const auto d = QIviWindowControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("blindMode")).value<QtIviVehicleFunctionsModule::BlindMode>();
    return d->m_blindMode;
}

void QIviWindowControl::setBlindMode(QtIviVehicleFunctionsModule::BlindMode blindMode)
{
    auto d = QIviWindowControlPrivate::get(this);
    bool forceUpdate = false;
    if (Q_UNLIKELY(d->m_propertyOverride)) {
        const int pi = metaObject()->indexOfProperty("blindMode");
        if (d->m_propertyOverride->isOverridden(pi)) {
            Q_EMIT blindModeChanged(d->m_propertyOverride->property(pi).value<QtIviVehicleFunctionsModule::BlindMode>());
            return;
        }
        forceUpdate = property("blindModeDirtyOverride").isValid();
        if (forceUpdate)
            setProperty("blindModeDirtyOverride", {});
        QVariant v = QVariant::fromValue<QtIviVehicleFunctionsModule::BlindMode>(blindMode);
        d->m_propertyOverride->setProperty(pi, v);
    }
    if (!forceUpdate && d->m_blindMode == blindMode)
        return;
    if (QIviWindowControlBackendInterface *backend = qiviwindowcontrolBackend())
        backend->setBlindMode(blindMode, zone());
    else
        Q_EMIT blindModeChanged(d->m_blindMode);
}


/*!
    \property QIviWindowControl::blindState

    Holds the current state of the window blind.
    

*/

/*!
    \qmlproperty QtIviVehicleFunctionsModule::WindowState WindowControl::blindState

    Holds the current state of the window blind.
    


    Available values are:
    \include qtivivehiclefunctionsmodule_enum.qdocinc WindowState
*/
QtIviVehicleFunctionsModule::WindowState QIviWindowControl::blindState() const
{
    const auto d = QIviWindowControlPrivate::get(this);
    if (Q_UNLIKELY(d->m_propertyOverride))
        return d->m_propertyOverride->property(metaObject()->indexOfProperty("blindState")).value<QtIviVehicleFunctionsModule::WindowState>();
    return d->m_blindState;
}

/*!
    \qmlmethod WindowControl::open()

    Opens the window, if not already in the QIviWindowControl::FullyOpen state.
    


*/
/*!

    Opens the window, if not already in the QIviWindowControl::FullyOpen state.
    

*/
QIviPendingReply<void> QIviWindowControl::open()
{
    if (QIviWindowControlBackendInterface *backend = qiviwindowcontrolBackend())
        return backend->open(zone());
    return QIviPendingReply<void>::createFailedReply();
}

/*!
    \qmlmethod WindowControl::close()

    Closes the window, if not already in the QIviWindowControl::Closed state.
    


*/
/*!

    Closes the window, if not already in the QIviWindowControl::Closed state.
    

*/
QIviPendingReply<void> QIviWindowControl::close()
{
    if (QIviWindowControlBackendInterface *backend = qiviwindowcontrolBackend())
        return backend->close(zone());
    return QIviPendingReply<void>::createFailedReply();
}


/*! \internal */
QIviAbstractZonedFeature *QIviWindowControl::createZoneFeature(const QString &zone)
{
    return new QIviWindowControl(zone, this);
}

/*! \internal */
void QIviWindowControl::connectToServiceObject(QIviServiceObject *serviceObject)
{
    auto d = QIviWindowControlPrivate::get(this);

    auto *backend = qiviwindowcontrolBackend();
    if (!backend)
        return;

    QObjectPrivate::connect(backend, &QIviWindowControlBackendInterface::heaterModeChanged,
        d, &QIviWindowControlPrivate::onHeaterModeChanged);
    QObjectPrivate::connect(backend, &QIviWindowControlBackendInterface::heaterChanged,
        d, &QIviWindowControlPrivate::onHeaterChanged);
    QObjectPrivate::connect(backend, &QIviWindowControlBackendInterface::stateChanged,
        d, &QIviWindowControlPrivate::onStateChanged);
    QObjectPrivate::connect(backend, &QIviWindowControlBackendInterface::blindModeChanged,
        d, &QIviWindowControlPrivate::onBlindModeChanged);
    QObjectPrivate::connect(backend, &QIviWindowControlBackendInterface::blindStateChanged,
        d, &QIviWindowControlPrivate::onBlindStateChanged);

    QIviAbstractZonedFeature::connectToServiceObject(serviceObject);
}

/*! \internal */
void QIviWindowControl::clearServiceObject()
{
    auto d = QIviWindowControlPrivate::get(this);
    d->clearToDefaults();
    QIviAbstractZonedFeature::clearServiceObject();
}

/*! \internal */
QIviWindowControlBackendInterface *QIviWindowControl::qiviwindowcontrolBackend() const
{
    return qivi_interface_cast<QIviWindowControlBackendInterface*>(backend());
}

QT_END_NAMESPACE

#include "moc_qiviwindowcontrol.cpp"
