#ifndef REP_QIVIMEDIADISCOVERYMODEL_SOURCE_H
#define REP_QIVIMEDIADISCOVERYMODEL_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>


class QIviMediaDiscoveryModelSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "QIviMediaDiscoveryModel")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "082077ed7c5d1ed35dd9deb8a4634a7bdb219757")
    Q_PROPERTY(QStringList devices READ devices NOTIFY devicesChanged)

public:
    explicit QIviMediaDiscoveryModelSource(QObject *parent = nullptr) : QObject(parent)
    {
    }

public:
    ~QIviMediaDiscoveryModelSource() override = default;

    virtual QStringList devices() const = 0;

Q_SIGNALS:
    void devicesChanged(QStringList devices);
    void deviceAdded(const QString & device);
    void deviceRemoved(const QString & device);

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class QIviMediaDiscoveryModelSimpleSource : public QIviMediaDiscoveryModelSource
{
    Q_OBJECT

public:
    explicit QIviMediaDiscoveryModelSimpleSource(QObject *parent = nullptr) : QIviMediaDiscoveryModelSource(parent)
    , m_devices()
    {
    }

public:
    ~QIviMediaDiscoveryModelSimpleSource() override = default;

    QStringList devices() const override { return m_devices; }

protected:
    virtual void setDevices(QStringList devices)
    {
        if (devices != m_devices) {
            m_devices = devices;
            Q_EMIT devicesChanged(m_devices);
        }
    }

private:
    QStringList m_devices;
};


template <class ObjectType>
struct QIviMediaDiscoveryModelSourceAPI : public SourceApiMap
{
    QIviMediaDiscoveryModelSourceAPI(ObjectType *object, const QString &name = QLatin1String("QIviMediaDiscoveryModel"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::devices, static_cast<QStringList (QObject::*)()>(0),"devices");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::devicesChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 3;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::devicesChanged, static_cast<void (QObject::*)(QStringList)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::deviceAdded, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::deviceRemoved, static_cast<void (QObject::*)(QString)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_methods[0] = 0;
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("QIviMediaDiscoveryModel"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override { Q_UNUSED(index); return -1; }
    int methodParameterType(int methodIndex, int paramIndex) const override
    { Q_UNUSED(methodIndex); Q_UNUSED(paramIndex); return -1; }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("devicesChanged(QStringList)");
        case 1: return QByteArrayLiteral("deviceAdded(QString)");
        case 2: return QByteArrayLiteral("deviceRemoved(QString)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        Q_UNUSED(index);
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        Q_UNUSED(index);
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"082077ed7c5d1ed35dd9deb8a4634a7bdb219757"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[4];
    int m_methods[1];
    const QString m_name;
    int m_signalArgCount[3];
    const int* m_signalArgTypes[3];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_QIVIMEDIADISCOVERYMODEL_SOURCE_H
