#ifndef REP_QIVIMEDIAINDEXER_SOURCE_H
#define REP_QIVIMEDIAINDEXER_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtIviMedia/QIviMediaIndexerControl>

class QIviMediaIndexerSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "QIviMediaIndexer")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "85d5ceb532232b453e2d5907399df6d7dfb4df83")
    Q_PROPERTY(QIviMediaIndexerControl::State state READ state NOTIFY stateChanged)
    Q_PROPERTY(qreal progress READ progress NOTIFY progressChanged)

public:
    explicit QIviMediaIndexerSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QIviMediaIndexerControl::State>();
        qRegisterMetaTypeStreamOperators<QIviMediaIndexerControl::State>();

    }

public:
    ~QIviMediaIndexerSource() override = default;

    virtual QIviMediaIndexerControl::State state() const = 0;
    virtual qreal progress() const = 0;

Q_SIGNALS:
    void stateChanged(QIviMediaIndexerControl::State state);
    void progressChanged(qreal progress);

public Q_SLOTS:
    virtual QVariant pause() = 0;
    virtual QVariant resume() = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class QIviMediaIndexerSimpleSource : public QIviMediaIndexerSource
{
    Q_OBJECT

public:
    explicit QIviMediaIndexerSimpleSource(QObject *parent = nullptr) : QIviMediaIndexerSource(parent)
    , m_state()
    , m_progress()
    {
    }

public:
    ~QIviMediaIndexerSimpleSource() override = default;

    QIviMediaIndexerControl::State state() const override { return m_state; }
    qreal progress() const override { return m_progress; }

protected:
    virtual void setState(QIviMediaIndexerControl::State state)
    {
        if (state != m_state) {
            m_state = state;
            Q_EMIT stateChanged(m_state);
        }
    }
    virtual void setProgress(qreal progress)
    {
        if (progress != m_progress) {
            m_progress = progress;
            Q_EMIT progressChanged(m_progress);
        }
    }

private:
    QIviMediaIndexerControl::State m_state;
    qreal m_progress;
};


template <class ObjectType>
struct QIviMediaIndexerSourceAPI : public SourceApiMap
{
    QIviMediaIndexerSourceAPI(ObjectType *object, const QString &name = QLatin1String("QIviMediaIndexer"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 2;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::state, static_cast<QIviMediaIndexerControl::State (QObject::*)()>(0),"state");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::stateChanged, static_cast<void (QObject::*)()>(0));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::progress, static_cast<qreal (QObject::*)()>(0),"progress");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::progressChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 2;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::stateChanged, static_cast<void (QObject::*)(QIviMediaIndexerControl::State)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::progressChanged, static_cast<void (QObject::*)(qreal)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_methods[0] = 2;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pause, static_cast<void (QObject::*)()>(0),"pause()",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::resume, static_cast<void (QObject::*)()>(0),"resume()",m_methodArgCount+1,&m_methodArgTypes[1]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("QIviMediaIndexer"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("stateChanged(QIviMediaIndexerControl::State)");
        case 1: return QByteArrayLiteral("progressChanged(qreal)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pause()");
        case 1: return QByteArrayLiteral("resume()");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("QVariant");
        case 1: return QByteArrayLiteral("QVariant");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"85d5ceb532232b453e2d5907399df6d7dfb4df83"}; }

    int m_enums[1];
    int m_properties[3];
    int m_signals[3];
    int m_methods[3];
    const QString m_name;
    int m_signalArgCount[2];
    const int* m_signalArgTypes[2];
    int m_methodArgCount[2];
    const int* m_methodArgTypes[2];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_QIVIMEDIAINDEXER_SOURCE_H
