#ifndef REP_QIVIMEDIAPLAYER_SOURCE_H
#define REP_QIVIMEDIAPLAYER_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtIviMedia/QIviMediaPlayer>

#include <QtCore/QUuid>

class QIviMediaPlayerSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "QIviMediaPlayer")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "e89f9db6db320b903fdf9f127274fdbadb87600b")
    Q_PROPERTY(QIviMediaPlayer::PlayMode playMode READ playMode WRITE setPlayMode NOTIFY playModeChanged)
    Q_PROPERTY(QIviMediaPlayer::PlayState playState READ playState NOTIFY playStateChanged)
    Q_PROPERTY(qint64 position READ position WRITE setPosition NOTIFY positionChanged)
    Q_PROPERTY(qint64 duration READ duration NOTIFY durationChanged)
    Q_PROPERTY(QVariant currentTrack READ currentTrack NOTIFY currentTrackChanged)
    Q_PROPERTY(int currentIndex READ currentIndex WRITE setCurrentIndex NOTIFY currentIndexChanged)
    Q_PROPERTY(int volume READ volume WRITE setVolume NOTIFY volumeChanged)
    Q_PROPERTY(bool muted READ muted WRITE setMuted NOTIFY mutedChanged)
    Q_PROPERTY(bool canReportCount READ canReportCount NOTIFY canReportCountChanged)

public:
    explicit QIviMediaPlayerSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QIviMediaPlayer::PlayMode>();
        qRegisterMetaTypeStreamOperators<QIviMediaPlayer::PlayMode>();
        qRegisterMetaType<QIviMediaPlayer::PlayState>();
        qRegisterMetaTypeStreamOperators<QIviMediaPlayer::PlayState>();

    }

public:
    ~QIviMediaPlayerSource() override = default;

    virtual QIviMediaPlayer::PlayMode playMode() const = 0;
    virtual QIviMediaPlayer::PlayState playState() const = 0;
    virtual qint64 position() const = 0;
    virtual qint64 duration() const = 0;
    virtual QVariant currentTrack() const = 0;
    virtual int currentIndex() const = 0;
    virtual int volume() const = 0;
    virtual bool muted() const = 0;
    virtual bool canReportCount() const = 0;
    virtual void setPlayMode(QIviMediaPlayer::PlayMode playMode) = 0;
    virtual void setPosition(qint64 position) = 0;
    virtual void setCurrentIndex(int currentIndex) = 0;
    virtual void setVolume(int volume) = 0;
    virtual void setMuted(bool muted) = 0;

Q_SIGNALS:
    void playModeChanged(QIviMediaPlayer::PlayMode playMode);
    void playStateChanged(QIviMediaPlayer::PlayState playState);
    void positionChanged(qint64 position);
    void durationChanged(qint64 duration);
    void currentTrackChanged(QVariant currentTrack);
    void currentIndexChanged(int currentIndex);
    void volumeChanged(int volume);
    void mutedChanged(bool muted);
    void canReportCountChanged(bool canReportCount);
    void countChanged(int newLength);
    void dataFetched(const QUuid & identifier, const QList<QVariant> & data, int start, bool moreAvailable);
    void dataChanged(const QList<QVariant> & data, int start, int count);

public Q_SLOTS:
    virtual void pushPlayMode(QIviMediaPlayer::PlayMode playMode)
    {
        setPlayMode(playMode);
    }
    virtual void pushPosition(qint64 position)
    {
        setPosition(position);
    }
    virtual void pushCurrentIndex(int currentIndex)
    {
        setCurrentIndex(currentIndex);
    }
    virtual void pushVolume(int volume)
    {
        setVolume(volume);
    }
    virtual void pushMuted(bool muted)
    {
        setMuted(muted);
    }
    virtual void play() = 0;
    virtual void pause() = 0;
    virtual void stop() = 0;
    virtual void seek(qint64 offset) = 0;
    virtual void next() = 0;
    virtual void previous() = 0;
    virtual void fetchData(const QUuid & identifier, int start, int count) = 0;
    virtual void insert(int index, const QVariant & item) = 0;
    virtual void remove(int index) = 0;
    virtual void move(int currentIndex, int newIndex) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class QIviMediaPlayerSimpleSource : public QIviMediaPlayerSource
{
    Q_OBJECT

public:
    explicit QIviMediaPlayerSimpleSource(QObject *parent = nullptr) : QIviMediaPlayerSource(parent)
    , m_playMode()
    , m_playState()
    , m_position()
    , m_duration()
    , m_currentTrack()
    , m_currentIndex()
    , m_volume()
    , m_muted()
    , m_canReportCount()
    {
    }

public:
    ~QIviMediaPlayerSimpleSource() override = default;

    QIviMediaPlayer::PlayMode playMode() const override { return m_playMode; }
    QIviMediaPlayer::PlayState playState() const override { return m_playState; }
    qint64 position() const override { return m_position; }
    qint64 duration() const override { return m_duration; }
    QVariant currentTrack() const override { return m_currentTrack; }
    int currentIndex() const override { return m_currentIndex; }
    int volume() const override { return m_volume; }
    bool muted() const override { return m_muted; }
    bool canReportCount() const override { return m_canReportCount; }
    void setPlayMode(QIviMediaPlayer::PlayMode playMode) override
    {
        if (playMode != m_playMode) {
            m_playMode = playMode;
            Q_EMIT playModeChanged(m_playMode);
        }
    }
    void setPosition(qint64 position) override
    {
        if (position != m_position) {
            m_position = position;
            Q_EMIT positionChanged(m_position);
        }
    }
    void setCurrentIndex(int currentIndex) override
    {
        if (currentIndex != m_currentIndex) {
            m_currentIndex = currentIndex;
            Q_EMIT currentIndexChanged(m_currentIndex);
        }
    }
    void setVolume(int volume) override
    {
        if (volume != m_volume) {
            m_volume = volume;
            Q_EMIT volumeChanged(m_volume);
        }
    }
    void setMuted(bool muted) override
    {
        if (muted != m_muted) {
            m_muted = muted;
            Q_EMIT mutedChanged(m_muted);
        }
    }

protected:
    virtual void setPlayState(QIviMediaPlayer::PlayState playState)
    {
        if (playState != m_playState) {
            m_playState = playState;
            Q_EMIT playStateChanged(m_playState);
        }
    }
    virtual void setDuration(qint64 duration)
    {
        if (duration != m_duration) {
            m_duration = duration;
            Q_EMIT durationChanged(m_duration);
        }
    }
    virtual void setCurrentTrack(QVariant currentTrack)
    {
        if (currentTrack != m_currentTrack) {
            m_currentTrack = currentTrack;
            Q_EMIT currentTrackChanged(m_currentTrack);
        }
    }
    virtual void setCanReportCount(bool canReportCount)
    {
        if (canReportCount != m_canReportCount) {
            m_canReportCount = canReportCount;
            Q_EMIT canReportCountChanged(m_canReportCount);
        }
    }

private:
    QIviMediaPlayer::PlayMode m_playMode;
    QIviMediaPlayer::PlayState m_playState;
    qint64 m_position;
    qint64 m_duration;
    QVariant m_currentTrack;
    int m_currentIndex;
    int m_volume;
    bool m_muted;
    bool m_canReportCount;
};


template <class ObjectType>
struct QIviMediaPlayerSourceAPI : public SourceApiMap
{
    QIviMediaPlayerSourceAPI(ObjectType *object, const QString &name = QLatin1String("QIviMediaPlayer"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 9;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::playMode, static_cast<QIviMediaPlayer::PlayMode (QObject::*)()>(0),"playMode");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::playModeChanged, static_cast<void (QObject::*)()>(0));
        m_properties[2] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::playState, static_cast<QIviMediaPlayer::PlayState (QObject::*)()>(0),"playState");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::playStateChanged, static_cast<void (QObject::*)()>(0));
        m_properties[3] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::position, static_cast<qint64 (QObject::*)()>(0),"position");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::positionChanged, static_cast<void (QObject::*)()>(0));
        m_properties[4] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::duration, static_cast<qint64 (QObject::*)()>(0),"duration");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::durationChanged, static_cast<void (QObject::*)()>(0));
        m_properties[5] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::currentTrack, static_cast<QVariant (QObject::*)()>(0),"currentTrack");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::currentTrackChanged, static_cast<void (QObject::*)()>(0));
        m_properties[6] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::currentIndex, static_cast<int (QObject::*)()>(0),"currentIndex");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::currentIndexChanged, static_cast<void (QObject::*)()>(0));
        m_properties[7] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::volume, static_cast<int (QObject::*)()>(0),"volume");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::volumeChanged, static_cast<void (QObject::*)()>(0));
        m_properties[8] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::muted, static_cast<bool (QObject::*)()>(0),"muted");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::mutedChanged, static_cast<void (QObject::*)()>(0));
        m_properties[9] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::canReportCount, static_cast<bool (QObject::*)()>(0),"canReportCount");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::canReportCountChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 12;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::playModeChanged, static_cast<void (QObject::*)(QIviMediaPlayer::PlayMode)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::playStateChanged, static_cast<void (QObject::*)(QIviMediaPlayer::PlayState)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::positionChanged, static_cast<void (QObject::*)(qint64)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::durationChanged, static_cast<void (QObject::*)(qint64)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::currentTrackChanged, static_cast<void (QObject::*)(QVariant)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::currentIndexChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_signals[7] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::volumeChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+6,&m_signalArgTypes[6]);
        m_signals[8] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::mutedChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+7,&m_signalArgTypes[7]);
        m_signals[9] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::canReportCountChanged, static_cast<void (QObject::*)(bool)>(0),m_signalArgCount+8,&m_signalArgTypes[8]);
        m_signals[10] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::countChanged, static_cast<void (QObject::*)(int)>(0),m_signalArgCount+9,&m_signalArgTypes[9]);
        m_signals[11] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::dataFetched, static_cast<void (QObject::*)(QUuid,QList<QVariant>,int,bool)>(0),m_signalArgCount+10,&m_signalArgTypes[10]);
        m_signals[12] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::dataChanged, static_cast<void (QObject::*)(QList<QVariant>,int,int)>(0),m_signalArgCount+11,&m_signalArgTypes[11]);
        m_methods[0] = 15;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushPlayMode, static_cast<void (QObject::*)(QIviMediaPlayer::PlayMode)>(0),"pushPlayMode(QIviMediaPlayer::PlayMode)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushPosition, static_cast<void (QObject::*)(qint64)>(0),"pushPosition(qint64)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushCurrentIndex, static_cast<void (QObject::*)(int)>(0),"pushCurrentIndex(int)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushVolume, static_cast<void (QObject::*)(int)>(0),"pushVolume(int)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pushMuted, static_cast<void (QObject::*)(bool)>(0),"pushMuted(bool)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::play, static_cast<void (QObject::*)()>(0),"play()",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::pause, static_cast<void (QObject::*)()>(0),"pause()",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::stop, static_cast<void (QObject::*)()>(0),"stop()",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_methods[9] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::seek, static_cast<void (QObject::*)(qint64)>(0),"seek(qint64)",m_methodArgCount+8,&m_methodArgTypes[8]);
        m_methods[10] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::next, static_cast<void (QObject::*)()>(0),"next()",m_methodArgCount+9,&m_methodArgTypes[9]);
        m_methods[11] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::previous, static_cast<void (QObject::*)()>(0),"previous()",m_methodArgCount+10,&m_methodArgTypes[10]);
        m_methods[12] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::fetchData, static_cast<void (QObject::*)(QUuid,int,int)>(0),"fetchData(QUuid,int,int)",m_methodArgCount+11,&m_methodArgTypes[11]);
        m_methods[13] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::insert, static_cast<void (QObject::*)(int,QVariant)>(0),"insert(int,QVariant)",m_methodArgCount+12,&m_methodArgTypes[12]);
        m_methods[14] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::remove, static_cast<void (QObject::*)(int)>(0),"remove(int)",m_methodArgCount+13,&m_methodArgTypes[13]);
        m_methods[15] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::move, static_cast<void (QObject::*)(int,int)>(0),"move(int,int)",m_methodArgCount+14,&m_methodArgTypes[14]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("QIviMediaPlayer"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        case 1: return m_properties[2];
        case 2: return m_properties[3];
        case 3: return m_properties[4];
        case 4: return m_properties[5];
        case 5: return m_properties[6];
        case 6: return m_properties[7];
        case 7: return m_properties[8];
        case 8: return m_properties[9];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        case 1: return 1;
        case 2: return 2;
        case 3: return 3;
        case 4: return 4;
        case 5: return 5;
        case 6: return 6;
        case 7: return 7;
        case 8: return 8;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("playModeChanged(QIviMediaPlayer::PlayMode)");
        case 1: return QByteArrayLiteral("playStateChanged(QIviMediaPlayer::PlayState)");
        case 2: return QByteArrayLiteral("positionChanged(qint64)");
        case 3: return QByteArrayLiteral("durationChanged(qint64)");
        case 4: return QByteArrayLiteral("currentTrackChanged(QVariant)");
        case 5: return QByteArrayLiteral("currentIndexChanged(int)");
        case 6: return QByteArrayLiteral("volumeChanged(int)");
        case 7: return QByteArrayLiteral("mutedChanged(bool)");
        case 8: return QByteArrayLiteral("canReportCountChanged(bool)");
        case 9: return QByteArrayLiteral("countChanged(int)");
        case 10: return QByteArrayLiteral("dataFetched(QUuid,QList<QVariant>,int,bool)");
        case 11: return QByteArrayLiteral("dataChanged(QList<QVariant>,int,int)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("pushPlayMode(QIviMediaPlayer::PlayMode)");
        case 1: return QByteArrayLiteral("pushPosition(qint64)");
        case 2: return QByteArrayLiteral("pushCurrentIndex(int)");
        case 3: return QByteArrayLiteral("pushVolume(int)");
        case 4: return QByteArrayLiteral("pushMuted(bool)");
        case 5: return QByteArrayLiteral("play()");
        case 6: return QByteArrayLiteral("pause()");
        case 7: return QByteArrayLiteral("stop()");
        case 8: return QByteArrayLiteral("seek(qint64)");
        case 9: return QByteArrayLiteral("next()");
        case 10: return QByteArrayLiteral("previous()");
        case 11: return QByteArrayLiteral("fetchData(QUuid,int,int)");
        case 12: return QByteArrayLiteral("insert(int,QVariant)");
        case 13: return QByteArrayLiteral("remove(int)");
        case 14: return QByteArrayLiteral("move(int,int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("void");
        case 3: return QByteArrayLiteral("void");
        case 4: return QByteArrayLiteral("void");
        case 5: return QByteArrayLiteral("void");
        case 6: return QByteArrayLiteral("void");
        case 7: return QByteArrayLiteral("void");
        case 8: return QByteArrayLiteral("void");
        case 9: return QByteArrayLiteral("void");
        case 10: return QByteArrayLiteral("void");
        case 11: return QByteArrayLiteral("void");
        case 12: return QByteArrayLiteral("void");
        case 13: return QByteArrayLiteral("void");
        case 14: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"e89f9db6db320b903fdf9f127274fdbadb87600b"}; }

    int m_enums[1];
    int m_properties[10];
    int m_signals[13];
    int m_methods[16];
    const QString m_name;
    int m_signalArgCount[12];
    const int* m_signalArgTypes[12];
    int m_methodArgCount[15];
    const int* m_methodArgTypes[15];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_QIVIMEDIAPLAYER_SOURCE_H
