#ifndef REP_QIVISEARCHANDBROWSEMODEL_SOURCE_H
#define REP_QIVISEARCHANDBROWSEMODEL_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtIviCore/QIviSearchAndBrowseModel>

#include <QtIviCore/QIviFilterTerm>

#include <QtCore/QUuid>

class QIviSearchAndBrowseModelSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "QIviSearchAndBrowseModel")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "da6e4ac67026a5fce39e7fab0c893fce1907b3a3")
    Q_PROPERTY(QStringList availableContentTypes READ availableContentTypes NOTIFY availableContentTypesChanged)

public:
    explicit QIviSearchAndBrowseModelSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QtIviCoreModule::ModelCapabilities>();
        qRegisterMetaTypeStreamOperators<QtIviCoreModule::ModelCapabilities>();
        qRegisterMetaType<QList<QIviOrderTerm>>();
        qRegisterMetaTypeStreamOperators<QList<QIviOrderTerm>>();
        qRegisterMetaType<QSet<QString>>();
        qRegisterMetaTypeStreamOperators<QSet<QString>>();
        qRegisterMetaType<QVector<bool>>();
        qRegisterMetaTypeStreamOperators<QVector<bool>>();

    }

public:
    ~QIviSearchAndBrowseModelSource() override = default;

    virtual QStringList availableContentTypes() const = 0;

Q_SIGNALS:
    void availableContentTypesChanged(QStringList availableContentTypes);
    void canGoForwardChanged(const QUuid & identifier, const QVector<bool> & indexes, int start);
    void canGoBackChanged(const QUuid & identifier, bool canGoBack);
    void supportedCapabilitiesChanged(const QUuid & identifier, QtIviCoreModule::ModelCapabilities capabilities);
    void contentTypeChanged(const QUuid & identifier, const QString & contentType);
    void queryIdentifiersChanged(const QUuid & identifier, const QSet<QString> & queryIdentifiers);
    void countChanged(const QUuid & identifier, int newLength);
    void dataFetched(const QUuid & identifier, const QList<QVariant> & data, int start, bool moreAvailable);
    void dataChanged(const QUuid & identifier, const QList<QVariant> & data, int start, int count);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual void setContentType(const QUuid & identifier, const QString & contentType) = 0;
    virtual void setupFilter(const QUuid & identifier, const QVariant & term, const QList<QIviOrderTerm> & orderTerms) = 0;
    virtual QVariant goBack(const QUuid & identifier) = 0;
    virtual QVariant goForward(const QUuid & identifier, int index) = 0;
    virtual QVariant insert(const QUuid & identifier, int index, const QVariant & item) = 0;
    virtual QVariant remove(const QUuid & identifier, int index) = 0;
    virtual QVariant move(const QUuid & identifier, int currentIndex, int newIndex) = 0;
    virtual QVariant indexOf(const QUuid & identifier, const QVariant & item) = 0;
    virtual void registerInstance(const QUuid & identifier) = 0;
    virtual void unregisterInstance(const QUuid & identifier) = 0;
    virtual void fetchData(const QUuid & identifier, int start, int count) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class QIviSearchAndBrowseModelSimpleSource : public QIviSearchAndBrowseModelSource
{
    Q_OBJECT

public:
    explicit QIviSearchAndBrowseModelSimpleSource(QObject *parent = nullptr) : QIviSearchAndBrowseModelSource(parent)
    , m_availableContentTypes()
    {
    }

public:
    ~QIviSearchAndBrowseModelSimpleSource() override = default;

    QStringList availableContentTypes() const override { return m_availableContentTypes; }

protected:
    virtual void setAvailableContentTypes(QStringList availableContentTypes)
    {
        if (availableContentTypes != m_availableContentTypes) {
            m_availableContentTypes = availableContentTypes;
            Q_EMIT availableContentTypesChanged(m_availableContentTypes);
        }
    }

private:
    QStringList m_availableContentTypes;
};


template <class ObjectType>
struct QIviSearchAndBrowseModelSourceAPI : public SourceApiMap
{
    QIviSearchAndBrowseModelSourceAPI(ObjectType *object, const QString &name = QLatin1String("QIviSearchAndBrowseModel"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 1;
        m_properties[1] = QtPrivate::qtro_property_index<ObjectType>(&ObjectType::availableContentTypes, static_cast<QStringList (QObject::*)()>(0),"availableContentTypes");
        QtPrivate::qtro_method_test<ObjectType>(&ObjectType::availableContentTypesChanged, static_cast<void (QObject::*)()>(0));
        m_signals[0] = 10;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::availableContentTypesChanged, static_cast<void (QObject::*)(QStringList)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::canGoForwardChanged, static_cast<void (QObject::*)(QUuid,QVector<bool>,int)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::canGoBackChanged, static_cast<void (QObject::*)(QUuid,bool)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::supportedCapabilitiesChanged, static_cast<void (QObject::*)(QUuid,QtIviCoreModule::ModelCapabilities)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::contentTypeChanged, static_cast<void (QObject::*)(QUuid,QString)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::queryIdentifiersChanged, static_cast<void (QObject::*)(QUuid,QSet<QString>)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_signals[7] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::countChanged, static_cast<void (QObject::*)(QUuid,int)>(0),m_signalArgCount+6,&m_signalArgTypes[6]);
        m_signals[8] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::dataFetched, static_cast<void (QObject::*)(QUuid,QList<QVariant>,int,bool)>(0),m_signalArgCount+7,&m_signalArgTypes[7]);
        m_signals[9] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::dataChanged, static_cast<void (QObject::*)(QUuid,QList<QVariant>,int,int)>(0),m_signalArgCount+8,&m_signalArgTypes[8]);
        m_signals[10] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+9,&m_signalArgTypes[9]);
        m_methods[0] = 11;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setContentType, static_cast<void (QObject::*)(QUuid,QString)>(0),"setContentType(QUuid,QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setupFilter, static_cast<void (QObject::*)(QUuid,QVariant,QList<QIviOrderTerm>)>(0),"setupFilter(QUuid,QVariant,QList<QIviOrderTerm>)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::goBack, static_cast<void (QObject::*)(QUuid)>(0),"goBack(QUuid)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::goForward, static_cast<void (QObject::*)(QUuid,int)>(0),"goForward(QUuid,int)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::insert, static_cast<void (QObject::*)(QUuid,int,QVariant)>(0),"insert(QUuid,int,QVariant)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::remove, static_cast<void (QObject::*)(QUuid,int)>(0),"remove(QUuid,int)",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::move, static_cast<void (QObject::*)(QUuid,int,int)>(0),"move(QUuid,int,int)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::indexOf, static_cast<void (QObject::*)(QUuid,QVariant)>(0),"indexOf(QUuid,QVariant)",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_methods[9] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::registerInstance, static_cast<void (QObject::*)(QUuid)>(0),"registerInstance(QUuid)",m_methodArgCount+8,&m_methodArgTypes[8]);
        m_methods[10] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::unregisterInstance, static_cast<void (QObject::*)(QUuid)>(0),"unregisterInstance(QUuid)",m_methodArgCount+9,&m_methodArgTypes[9]);
        m_methods[11] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::fetchData, static_cast<void (QObject::*)(QUuid,int,int)>(0),"fetchData(QUuid,int,int)",m_methodArgCount+10,&m_methodArgTypes[10]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("QIviSearchAndBrowseModel"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return m_properties[1];
        }
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        switch (index) {
        case 0: return 0;
        }
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("availableContentTypesChanged(QStringList)");
        case 1: return QByteArrayLiteral("canGoForwardChanged(QUuid,QVector<bool>,int)");
        case 2: return QByteArrayLiteral("canGoBackChanged(QUuid,bool)");
        case 3: return QByteArrayLiteral("supportedCapabilitiesChanged(QUuid,QtIviCoreModule::ModelCapabilities)");
        case 4: return QByteArrayLiteral("contentTypeChanged(QUuid,QString)");
        case 5: return QByteArrayLiteral("queryIdentifiersChanged(QUuid,QSet<QString>)");
        case 6: return QByteArrayLiteral("countChanged(QUuid,int)");
        case 7: return QByteArrayLiteral("dataFetched(QUuid,QList<QVariant>,int,bool)");
        case 8: return QByteArrayLiteral("dataChanged(QUuid,QList<QVariant>,int,int)");
        case 9: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("setContentType(QUuid,QString)");
        case 1: return QByteArrayLiteral("setupFilter(QUuid,QVariant,QList<QIviOrderTerm>)");
        case 2: return QByteArrayLiteral("goBack(QUuid)");
        case 3: return QByteArrayLiteral("goForward(QUuid,int)");
        case 4: return QByteArrayLiteral("insert(QUuid,int,QVariant)");
        case 5: return QByteArrayLiteral("remove(QUuid,int)");
        case 6: return QByteArrayLiteral("move(QUuid,int,int)");
        case 7: return QByteArrayLiteral("indexOf(QUuid,QVariant)");
        case 8: return QByteArrayLiteral("registerInstance(QUuid)");
        case 9: return QByteArrayLiteral("unregisterInstance(QUuid)");
        case 10: return QByteArrayLiteral("fetchData(QUuid,int,int)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("void");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("QVariant");
        case 3: return QByteArrayLiteral("QVariant");
        case 4: return QByteArrayLiteral("QVariant");
        case 5: return QByteArrayLiteral("QVariant");
        case 6: return QByteArrayLiteral("QVariant");
        case 7: return QByteArrayLiteral("QVariant");
        case 8: return QByteArrayLiteral("void");
        case 9: return QByteArrayLiteral("void");
        case 10: return QByteArrayLiteral("void");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"da6e4ac67026a5fce39e7fab0c893fce1907b3a3"}; }

    int m_enums[1];
    int m_properties[2];
    int m_signals[11];
    int m_methods[12];
    const QString m_name;
    int m_signalArgCount[10];
    const int* m_signalArgTypes[10];
    int m_methodArgCount[11];
    const int* m_methodArgTypes[11];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_QIVISEARCHANDBROWSEMODEL_SOURCE_H
