/****************************************************************************
** Generated from 'QtIviVehicleFunctions.qface'
**
** Created by: The QFace generator (QtAS 5.15.1)
**
** WARNING! All changes made in this file will be lost!
*****************************************************************************/

#include "qiviwindowcontrolbackend.h"

#include <QDebug>
#include <QtIviCore/QIviSimulationEngine>


QT_BEGIN_NAMESPACE

QIviWindowControlZone::QIviWindowControlZone(const QString &zone, QIviWindowControlBackendInterface *parent)
    : QObject(parent)
    , m_parent(parent)
    , m_zone(zone)
    , m_heaterMode(QtIviVehicleFunctionsModule::HeaterOn)
    , m_heater(bool(false))
    , m_state(QtIviVehicleFunctionsModule::FullyOpen)
    , m_blindMode(QtIviVehicleFunctionsModule::BlindOpen)
    , m_blindState(QtIviVehicleFunctionsModule::FullyOpen)
{
}

QtIviVehicleFunctionsModule::HeaterMode QIviWindowControlZone::heaterMode() const
{
    return m_heaterMode;
}
bool QIviWindowControlZone::heater() const
{
    return m_heater;
}
QtIviVehicleFunctionsModule::WindowState QIviWindowControlZone::state() const
{
    return m_state;
}
QtIviVehicleFunctionsModule::BlindMode QIviWindowControlZone::blindMode() const
{
    return m_blindMode;
}
QtIviVehicleFunctionsModule::WindowState QIviWindowControlZone::blindState() const
{
    return m_blindState;
}

void QIviWindowControlZone::setHeaterMode(QtIviVehicleFunctionsModule::HeaterMode heaterMode)
{
    if (m_heaterMode == heaterMode)
        return;
    m_heaterMode = heaterMode;
    Q_EMIT heaterModeChanged(heaterMode);
    Q_EMIT m_parent->heaterModeChanged(heaterMode, m_zone);
}
void QIviWindowControlZone::setHeater(bool heater)
{
    if (m_heater == heater)
        return;
    m_heater = heater;
    Q_EMIT heaterChanged(heater);
    Q_EMIT m_parent->heaterChanged(heater, m_zone);
}
void QIviWindowControlZone::setState(QtIviVehicleFunctionsModule::WindowState state)
{
    if (m_state == state)
        return;
    m_state = state;
    Q_EMIT stateChanged(state);
    Q_EMIT m_parent->stateChanged(state, m_zone);
}
void QIviWindowControlZone::setBlindMode(QtIviVehicleFunctionsModule::BlindMode blindMode)
{
    if (m_blindMode == blindMode)
        return;
    m_blindMode = blindMode;
    Q_EMIT blindModeChanged(blindMode);
    Q_EMIT m_parent->blindModeChanged(blindMode, m_zone);
}
void QIviWindowControlZone::setBlindState(QtIviVehicleFunctionsModule::WindowState blindState)
{
    if (m_blindState == blindState)
        return;
    m_blindState = blindState;
    Q_EMIT blindStateChanged(blindState);
    Q_EMIT m_parent->blindStateChanged(blindState, m_zone);
}

QIviWindowControlBackend::QIviWindowControlBackend(QObject *parent)
    : QIviWindowControlBackend(nullptr, parent)
{
}

QIviWindowControlBackend::QIviWindowControlBackend(QIviSimulationEngine *engine, QObject *parent)
    : QIviWindowControlBackendInterface(parent)
    , m_heaterMode(QtIviVehicleFunctionsModule::HeaterOn)
    , m_heater(bool(false))
    , m_state(QtIviVehicleFunctionsModule::FullyOpen)
    , m_blindMode(QtIviVehicleFunctionsModule::BlindOpen)
    , m_blindState(QtIviVehicleFunctionsModule::FullyOpen)
    , m_zones(new QQmlPropertyMap(this))
{
    //In some cases the engine is unused, this doesn't do any harm if it is still used
    Q_UNUSED(engine)
    qRegisterMetaType<QQmlPropertyMap*>();


    QtIviVehicleFunctionsModule::registerTypes();
}

QIviWindowControlBackend::~QIviWindowControlBackend()
{
}

QStringList QIviWindowControlBackend::availableZones() const
{
    QStringList zones;
    QIVI_SIMULATION_TRY_CALL_FUNC(QIviWindowControlBackend, "availableZones", zones = return_value.toStringList());

    for (const QString &zone : zones)
        const_cast<QIviWindowControlBackend*>(this)->addZone(zone);
    return zones;
}

void QIviWindowControlBackend::initialize()
{
    // To initialize the default values all zone objects need to be created. For zoned backends
    // the availableZones() method is responsible for that, just make sure this is called before
    // initialize to have them created before.
    availableZones();
    QIVI_SIMULATION_TRY_CALL(QIviWindowControlBackend, "initialize", void);

    for (const QString &zone : m_zones->keys()) {
        QIviWindowControlZone *zo = zoneAt(zone);
        Q_EMIT heaterModeChanged(zo->heaterMode(), zone);
        Q_EMIT heaterChanged(zo->heater(), zone);
        Q_EMIT stateChanged(zo->state(), zone);
        Q_EMIT blindModeChanged(zo->blindMode(), zone);
        Q_EMIT blindStateChanged(zo->blindState(), zone);
    }

    Q_EMIT initializationDone();
}

void QIviWindowControlBackend::addZone(const QString &zone)
{
    if (!m_zones->contains(zone))
        m_zones->insert(zone, QVariant::fromValue(new QIviWindowControlZone(zone, this)));
}

QIviWindowControlZone* QIviWindowControlBackend::zoneAt(const QString &zone)
{
    return m_zones->value(zone).value<QIviWindowControlZone*>();
}

QtIviVehicleFunctionsModule::HeaterMode QIviWindowControlBackend::heaterMode(const QString &zone)
{
    if (zone.isEmpty())
        return m_heaterMode;
    QIviWindowControlZone *zo = zoneAt(zone);
    if (zo)
        return zo->heaterMode();
    else
        qWarning() << "No such Zone";
    return QtIviVehicleFunctionsModule::HeaterOn;
}
bool QIviWindowControlBackend::heater(const QString &zone)
{
    if (zone.isEmpty())
        return m_heater;
    QIviWindowControlZone *zo = zoneAt(zone);
    if (zo)
        return zo->heater();
    else
        qWarning() << "No such Zone";
    return bool(false);
}
QtIviVehicleFunctionsModule::WindowState QIviWindowControlBackend::state(const QString &zone)
{
    if (zone.isEmpty())
        return m_state;
    QIviWindowControlZone *zo = zoneAt(zone);
    if (zo)
        return zo->state();
    else
        qWarning() << "No such Zone";
    return QtIviVehicleFunctionsModule::FullyOpen;
}
QtIviVehicleFunctionsModule::BlindMode QIviWindowControlBackend::blindMode(const QString &zone)
{
    if (zone.isEmpty())
        return m_blindMode;
    QIviWindowControlZone *zo = zoneAt(zone);
    if (zo)
        return zo->blindMode();
    else
        qWarning() << "No such Zone";
    return QtIviVehicleFunctionsModule::BlindOpen;
}
QtIviVehicleFunctionsModule::WindowState QIviWindowControlBackend::blindState(const QString &zone)
{
    if (zone.isEmpty())
        return m_blindState;
    QIviWindowControlZone *zo = zoneAt(zone);
    if (zo)
        return zo->blindState();
    else
        qWarning() << "No such Zone";
    return QtIviVehicleFunctionsModule::FullyOpen;
}

void QIviWindowControlBackend::setHeaterMode(QtIviVehicleFunctionsModule::HeaterMode heaterMode, const QString &zone)
{
    QIVI_SIMULATION_TRY_CALL(QIviWindowControlBackend, "setHeaterMode", void, heaterMode, zone);

    if (zone.isEmpty()) {
        if (m_heaterMode == heaterMode)
            return;
        m_heaterMode = heaterMode;
        Q_EMIT heaterModeChanged(heaterMode, QString());
    } else {
        QIviWindowControlZone *zo = zoneAt(zone);
        if (zo)
            zo->setHeaterMode(heaterMode);
        else
            qWarning() << "No such Zone";
    }
}

void QIviWindowControlBackend::setHeater(bool heater, const QString &zone)
{
    QIVI_SIMULATION_TRY_CALL(QIviWindowControlBackend, "setHeater", void, heater, zone);

    if (zone.isEmpty()) {
        if (m_heater == heater)
            return;
        m_heater = heater;
        Q_EMIT heaterChanged(heater, QString());
    } else {
        QIviWindowControlZone *zo = zoneAt(zone);
        if (zo)
            zo->setHeater(heater);
        else
            qWarning() << "No such Zone";
    }
}

void QIviWindowControlBackend::setState(QtIviVehicleFunctionsModule::WindowState state, const QString &zone)
{
    QIVI_SIMULATION_TRY_CALL(QIviWindowControlBackend, "setState", void, state, zone);

    if (zone.isEmpty()) {
        if (m_state == state)
            return;
        m_state = state;
        Q_EMIT stateChanged(state, QString());
    } else {
        QIviWindowControlZone *zo = zoneAt(zone);
        if (zo)
            zo->setState(state);
        else
            qWarning() << "No such Zone";
    }
}

void QIviWindowControlBackend::setBlindMode(QtIviVehicleFunctionsModule::BlindMode blindMode, const QString &zone)
{
    QIVI_SIMULATION_TRY_CALL(QIviWindowControlBackend, "setBlindMode", void, blindMode, zone);

    if (zone.isEmpty()) {
        if (m_blindMode == blindMode)
            return;
        m_blindMode = blindMode;
        Q_EMIT blindModeChanged(blindMode, QString());
    } else {
        QIviWindowControlZone *zo = zoneAt(zone);
        if (zo)
            zo->setBlindMode(blindMode);
        else
            qWarning() << "No such Zone";
    }
}

void QIviWindowControlBackend::setBlindState(QtIviVehicleFunctionsModule::WindowState blindState, const QString &zone)
{
    QIVI_SIMULATION_TRY_CALL(QIviWindowControlBackend, "setBlindState", void, blindState, zone);

    if (zone.isEmpty()) {
        if (m_blindState == blindState)
            return;
        m_blindState = blindState;
        Q_EMIT blindStateChanged(blindState, QString());
    } else {
        QIviWindowControlZone *zo = zoneAt(zone);
        if (zo)
            zo->setBlindState(blindState);
        else
            qWarning() << "No such Zone";
    }
}


QIviPendingReply<void> QIviWindowControlBackend::open(const QString &zone)
{
    QIviPendingReply<void> pendingReply;
    QIVI_SIMULATION_TRY_CALL_FUNC(QIviWindowControlBackend, "open", return pendingReply, QIviPendingReplyBase(pendingReply), zone );

    Q_UNUSED(zone);

    qWarning() << "open: Not implemented!";

    //Fake that the reply always succeeded
    QIviPendingReply<void> successReply;
    successReply.setSuccess();
    return successReply;
}

QIviPendingReply<void> QIviWindowControlBackend::close(const QString &zone)
{
    QIviPendingReply<void> pendingReply;
    QIVI_SIMULATION_TRY_CALL_FUNC(QIviWindowControlBackend, "close", return pendingReply, QIviPendingReplyBase(pendingReply), zone );

    Q_UNUSED(zone);

    qWarning() << "close: Not implemented!";

    //Fake that the reply always succeeded
    QIviPendingReply<void> successReply;
    successReply.setSuccess();
    return successReply;
}


QT_END_NAMESPACE
