#ifndef REP_QIVICLIMATECONTROL_SOURCE_H
#define REP_QIVICLIMATECONTROL_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtIviVehicleFunctions/qtivivehiclefunctionsmodule.h>

class QIviClimateControlSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "QIviClimateControl")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "aa69730a3066b0300abc4ff5849ef878699a69db")

public:
    explicit QIviClimateControlSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QtIviVehicleFunctionsModule::ClimateMode>();
        qRegisterMetaTypeStreamOperators<QtIviVehicleFunctionsModule::ClimateMode>();
        qRegisterMetaType<QtIviVehicleFunctionsModule::RecirculationMode>();
        qRegisterMetaTypeStreamOperators<QtIviVehicleFunctionsModule::RecirculationMode>();
        qRegisterMetaType<QtIviVehicleFunctionsModule::AirflowDirections>();
        qRegisterMetaTypeStreamOperators<QtIviVehicleFunctionsModule::AirflowDirections>();

    }

public:
    ~QIviClimateControlSource() override = default;


Q_SIGNALS:
    void airConditioningEnabledChanged(bool airConditioningEnabled, const QString & zone);
    void heaterEnabledChanged(bool heaterEnabled, const QString & zone);
    void fanSpeedLevelChanged(int fanSpeedLevel, const QString & zone);
    void steeringWheelHeaterChanged(int steeringWheelHeater, const QString & zone);
    void targetTemperatureChanged(qreal targetTemperature, const QString & zone);
    void seatCoolerChanged(int seatCooler, const QString & zone);
    void seatHeaterChanged(int seatHeater, const QString & zone);
    void outsideTemperatureChanged(int outsideTemperature, const QString & zone);
    void outsideTemperatureLabelChanged(const QString & outsideTemperatureLabel, const QString & zone);
    void zoneSynchronizationEnabledChanged(bool zoneSynchronizationEnabled, const QString & zone);
    void defrostEnabledChanged(bool defrostEnabled, const QString & zone);
    void recirculationModeChanged(QtIviVehicleFunctionsModule::RecirculationMode recirculationMode, const QString & zone);
    void recirculationEnabledChanged(bool recirculationEnabled, const QString & zone);
    void recirculationSensitivityLevelChanged(int recirculationSensitivityLevel, const QString & zone);
    void climateModeChanged(QtIviVehicleFunctionsModule::ClimateMode climateMode, const QString & zone);
    void automaticClimateFanIntensityLevelChanged(int automaticClimateFanIntensityLevel, const QString & zone);
    void airflowDirectionsChanged(QtIviVehicleFunctionsModule::AirflowDirections airflowDirections, const QString & zone);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual bool isAirConditioningEnabled(const QString & zone) = 0;
    virtual void setAirConditioningEnabled(bool airConditioningEnabled, const QString & zone) = 0;
    virtual bool isHeaterEnabled(const QString & zone) = 0;
    virtual void setHeaterEnabled(bool heaterEnabled, const QString & zone) = 0;
    virtual int fanSpeedLevel(const QString & zone) = 0;
    virtual void setFanSpeedLevel(int fanSpeedLevel, const QString & zone) = 0;
    virtual int steeringWheelHeater(const QString & zone) = 0;
    virtual void setSteeringWheelHeater(int steeringWheelHeater, const QString & zone) = 0;
    virtual qreal targetTemperature(const QString & zone) = 0;
    virtual void setTargetTemperature(qreal targetTemperature, const QString & zone) = 0;
    virtual int seatCooler(const QString & zone) = 0;
    virtual void setSeatCooler(int seatCooler, const QString & zone) = 0;
    virtual int seatHeater(const QString & zone) = 0;
    virtual void setSeatHeater(int seatHeater, const QString & zone) = 0;
    virtual int outsideTemperature(const QString & zone) = 0;
    virtual void setOutsideTemperature(int outsideTemperature, const QString & zone) = 0;
    virtual QString outsideTemperatureLabel(const QString & zone) = 0;
    virtual void setOutsideTemperatureLabel(const QString & outsideTemperatureLabel, const QString & zone) = 0;
    virtual bool isZoneSynchronizationEnabled(const QString & zone) = 0;
    virtual void setZoneSynchronizationEnabled(bool zoneSynchronizationEnabled, const QString & zone) = 0;
    virtual bool isDefrostEnabled(const QString & zone) = 0;
    virtual void setDefrostEnabled(bool defrostEnabled, const QString & zone) = 0;
    virtual QtIviVehicleFunctionsModule::RecirculationMode recirculationMode(const QString & zone) = 0;
    virtual void setRecirculationMode(QtIviVehicleFunctionsModule::RecirculationMode recirculationMode, const QString & zone) = 0;
    virtual bool isRecirculationEnabled(const QString & zone) = 0;
    virtual void setRecirculationEnabled(bool recirculationEnabled, const QString & zone) = 0;
    virtual int recirculationSensitivityLevel(const QString & zone) = 0;
    virtual void setRecirculationSensitivityLevel(int recirculationSensitivityLevel, const QString & zone) = 0;
    virtual QtIviVehicleFunctionsModule::ClimateMode climateMode(const QString & zone) = 0;
    virtual void setClimateMode(QtIviVehicleFunctionsModule::ClimateMode climateMode, const QString & zone) = 0;
    virtual int automaticClimateFanIntensityLevel(const QString & zone) = 0;
    virtual void setAutomaticClimateFanIntensityLevel(int automaticClimateFanIntensityLevel, const QString & zone) = 0;
    virtual QtIviVehicleFunctionsModule::AirflowDirections airflowDirections(const QString & zone) = 0;
    virtual void setAirflowDirections(QtIviVehicleFunctionsModule::AirflowDirections airflowDirections, const QString & zone) = 0;
    virtual QStringList availableZones() = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class QIviClimateControlSimpleSource : public QIviClimateControlSource
{
    Q_OBJECT

public:
    explicit QIviClimateControlSimpleSource(QObject *parent = nullptr) : QIviClimateControlSource(parent)
    {
    }

public:
    ~QIviClimateControlSimpleSource() override = default;


private:
};


template <class ObjectType>
struct QIviClimateControlSourceAPI : public SourceApiMap
{
    QIviClimateControlSourceAPI(ObjectType *object, const QString &name = QLatin1String("QIviClimateControl"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 0;
        m_signals[0] = 18;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::airConditioningEnabledChanged, static_cast<void (QObject::*)(bool,QString)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::heaterEnabledChanged, static_cast<void (QObject::*)(bool,QString)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::fanSpeedLevelChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::steeringWheelHeaterChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::targetTemperatureChanged, static_cast<void (QObject::*)(qreal,QString)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::seatCoolerChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_signals[7] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::seatHeaterChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+6,&m_signalArgTypes[6]);
        m_signals[8] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::outsideTemperatureChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+7,&m_signalArgTypes[7]);
        m_signals[9] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::outsideTemperatureLabelChanged, static_cast<void (QObject::*)(QString,QString)>(0),m_signalArgCount+8,&m_signalArgTypes[8]);
        m_signals[10] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::zoneSynchronizationEnabledChanged, static_cast<void (QObject::*)(bool,QString)>(0),m_signalArgCount+9,&m_signalArgTypes[9]);
        m_signals[11] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::defrostEnabledChanged, static_cast<void (QObject::*)(bool,QString)>(0),m_signalArgCount+10,&m_signalArgTypes[10]);
        m_signals[12] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::recirculationModeChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::RecirculationMode,QString)>(0),m_signalArgCount+11,&m_signalArgTypes[11]);
        m_signals[13] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::recirculationEnabledChanged, static_cast<void (QObject::*)(bool,QString)>(0),m_signalArgCount+12,&m_signalArgTypes[12]);
        m_signals[14] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::recirculationSensitivityLevelChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+13,&m_signalArgTypes[13]);
        m_signals[15] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::climateModeChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::ClimateMode,QString)>(0),m_signalArgCount+14,&m_signalArgTypes[14]);
        m_signals[16] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::automaticClimateFanIntensityLevelChanged, static_cast<void (QObject::*)(int,QString)>(0),m_signalArgCount+15,&m_signalArgTypes[15]);
        m_signals[17] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::airflowDirectionsChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::AirflowDirections,QString)>(0),m_signalArgCount+16,&m_signalArgTypes[16]);
        m_signals[18] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+17,&m_signalArgTypes[17]);
        m_methods[0] = 35;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::isAirConditioningEnabled, static_cast<void (QObject::*)(QString)>(0),"isAirConditioningEnabled(QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setAirConditioningEnabled, static_cast<void (QObject::*)(bool,QString)>(0),"setAirConditioningEnabled(bool,QString)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::isHeaterEnabled, static_cast<void (QObject::*)(QString)>(0),"isHeaterEnabled(QString)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setHeaterEnabled, static_cast<void (QObject::*)(bool,QString)>(0),"setHeaterEnabled(bool,QString)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::fanSpeedLevel, static_cast<void (QObject::*)(QString)>(0),"fanSpeedLevel(QString)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setFanSpeedLevel, static_cast<void (QObject::*)(int,QString)>(0),"setFanSpeedLevel(int,QString)",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::steeringWheelHeater, static_cast<void (QObject::*)(QString)>(0),"steeringWheelHeater(QString)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setSteeringWheelHeater, static_cast<void (QObject::*)(int,QString)>(0),"setSteeringWheelHeater(int,QString)",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_methods[9] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::targetTemperature, static_cast<void (QObject::*)(QString)>(0),"targetTemperature(QString)",m_methodArgCount+8,&m_methodArgTypes[8]);
        m_methods[10] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setTargetTemperature, static_cast<void (QObject::*)(qreal,QString)>(0),"setTargetTemperature(qreal,QString)",m_methodArgCount+9,&m_methodArgTypes[9]);
        m_methods[11] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::seatCooler, static_cast<void (QObject::*)(QString)>(0),"seatCooler(QString)",m_methodArgCount+10,&m_methodArgTypes[10]);
        m_methods[12] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setSeatCooler, static_cast<void (QObject::*)(int,QString)>(0),"setSeatCooler(int,QString)",m_methodArgCount+11,&m_methodArgTypes[11]);
        m_methods[13] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::seatHeater, static_cast<void (QObject::*)(QString)>(0),"seatHeater(QString)",m_methodArgCount+12,&m_methodArgTypes[12]);
        m_methods[14] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setSeatHeater, static_cast<void (QObject::*)(int,QString)>(0),"setSeatHeater(int,QString)",m_methodArgCount+13,&m_methodArgTypes[13]);
        m_methods[15] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::outsideTemperature, static_cast<void (QObject::*)(QString)>(0),"outsideTemperature(QString)",m_methodArgCount+14,&m_methodArgTypes[14]);
        m_methods[16] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setOutsideTemperature, static_cast<void (QObject::*)(int,QString)>(0),"setOutsideTemperature(int,QString)",m_methodArgCount+15,&m_methodArgTypes[15]);
        m_methods[17] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::outsideTemperatureLabel, static_cast<void (QObject::*)(QString)>(0),"outsideTemperatureLabel(QString)",m_methodArgCount+16,&m_methodArgTypes[16]);
        m_methods[18] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setOutsideTemperatureLabel, static_cast<void (QObject::*)(QString,QString)>(0),"setOutsideTemperatureLabel(QString,QString)",m_methodArgCount+17,&m_methodArgTypes[17]);
        m_methods[19] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::isZoneSynchronizationEnabled, static_cast<void (QObject::*)(QString)>(0),"isZoneSynchronizationEnabled(QString)",m_methodArgCount+18,&m_methodArgTypes[18]);
        m_methods[20] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setZoneSynchronizationEnabled, static_cast<void (QObject::*)(bool,QString)>(0),"setZoneSynchronizationEnabled(bool,QString)",m_methodArgCount+19,&m_methodArgTypes[19]);
        m_methods[21] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::isDefrostEnabled, static_cast<void (QObject::*)(QString)>(0),"isDefrostEnabled(QString)",m_methodArgCount+20,&m_methodArgTypes[20]);
        m_methods[22] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setDefrostEnabled, static_cast<void (QObject::*)(bool,QString)>(0),"setDefrostEnabled(bool,QString)",m_methodArgCount+21,&m_methodArgTypes[21]);
        m_methods[23] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::recirculationMode, static_cast<void (QObject::*)(QString)>(0),"recirculationMode(QString)",m_methodArgCount+22,&m_methodArgTypes[22]);
        m_methods[24] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setRecirculationMode, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::RecirculationMode,QString)>(0),"setRecirculationMode(QtIviVehicleFunctionsModule::RecirculationMode,QString)",m_methodArgCount+23,&m_methodArgTypes[23]);
        m_methods[25] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::isRecirculationEnabled, static_cast<void (QObject::*)(QString)>(0),"isRecirculationEnabled(QString)",m_methodArgCount+24,&m_methodArgTypes[24]);
        m_methods[26] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setRecirculationEnabled, static_cast<void (QObject::*)(bool,QString)>(0),"setRecirculationEnabled(bool,QString)",m_methodArgCount+25,&m_methodArgTypes[25]);
        m_methods[27] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::recirculationSensitivityLevel, static_cast<void (QObject::*)(QString)>(0),"recirculationSensitivityLevel(QString)",m_methodArgCount+26,&m_methodArgTypes[26]);
        m_methods[28] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setRecirculationSensitivityLevel, static_cast<void (QObject::*)(int,QString)>(0),"setRecirculationSensitivityLevel(int,QString)",m_methodArgCount+27,&m_methodArgTypes[27]);
        m_methods[29] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::climateMode, static_cast<void (QObject::*)(QString)>(0),"climateMode(QString)",m_methodArgCount+28,&m_methodArgTypes[28]);
        m_methods[30] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setClimateMode, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::ClimateMode,QString)>(0),"setClimateMode(QtIviVehicleFunctionsModule::ClimateMode,QString)",m_methodArgCount+29,&m_methodArgTypes[29]);
        m_methods[31] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::automaticClimateFanIntensityLevel, static_cast<void (QObject::*)(QString)>(0),"automaticClimateFanIntensityLevel(QString)",m_methodArgCount+30,&m_methodArgTypes[30]);
        m_methods[32] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setAutomaticClimateFanIntensityLevel, static_cast<void (QObject::*)(int,QString)>(0),"setAutomaticClimateFanIntensityLevel(int,QString)",m_methodArgCount+31,&m_methodArgTypes[31]);
        m_methods[33] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::airflowDirections, static_cast<void (QObject::*)(QString)>(0),"airflowDirections(QString)",m_methodArgCount+32,&m_methodArgTypes[32]);
        m_methods[34] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setAirflowDirections, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::AirflowDirections,QString)>(0),"setAirflowDirections(QtIviVehicleFunctionsModule::AirflowDirections,QString)",m_methodArgCount+33,&m_methodArgTypes[33]);
        m_methods[35] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::availableZones, static_cast<void (QObject::*)()>(0),"availableZones()",m_methodArgCount+34,&m_methodArgTypes[34]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("QIviClimateControl"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        Q_UNUSED(index);
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        Q_UNUSED(index);
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("airConditioningEnabledChanged(bool,QString)");
        case 1: return QByteArrayLiteral("heaterEnabledChanged(bool,QString)");
        case 2: return QByteArrayLiteral("fanSpeedLevelChanged(int,QString)");
        case 3: return QByteArrayLiteral("steeringWheelHeaterChanged(int,QString)");
        case 4: return QByteArrayLiteral("targetTemperatureChanged(qreal,QString)");
        case 5: return QByteArrayLiteral("seatCoolerChanged(int,QString)");
        case 6: return QByteArrayLiteral("seatHeaterChanged(int,QString)");
        case 7: return QByteArrayLiteral("outsideTemperatureChanged(int,QString)");
        case 8: return QByteArrayLiteral("outsideTemperatureLabelChanged(QString,QString)");
        case 9: return QByteArrayLiteral("zoneSynchronizationEnabledChanged(bool,QString)");
        case 10: return QByteArrayLiteral("defrostEnabledChanged(bool,QString)");
        case 11: return QByteArrayLiteral("recirculationModeChanged(QtIviVehicleFunctionsModule::RecirculationMode,QString)");
        case 12: return QByteArrayLiteral("recirculationEnabledChanged(bool,QString)");
        case 13: return QByteArrayLiteral("recirculationSensitivityLevelChanged(int,QString)");
        case 14: return QByteArrayLiteral("climateModeChanged(QtIviVehicleFunctionsModule::ClimateMode,QString)");
        case 15: return QByteArrayLiteral("automaticClimateFanIntensityLevelChanged(int,QString)");
        case 16: return QByteArrayLiteral("airflowDirectionsChanged(QtIviVehicleFunctionsModule::AirflowDirections,QString)");
        case 17: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("isAirConditioningEnabled(QString)");
        case 1: return QByteArrayLiteral("setAirConditioningEnabled(bool,QString)");
        case 2: return QByteArrayLiteral("isHeaterEnabled(QString)");
        case 3: return QByteArrayLiteral("setHeaterEnabled(bool,QString)");
        case 4: return QByteArrayLiteral("fanSpeedLevel(QString)");
        case 5: return QByteArrayLiteral("setFanSpeedLevel(int,QString)");
        case 6: return QByteArrayLiteral("steeringWheelHeater(QString)");
        case 7: return QByteArrayLiteral("setSteeringWheelHeater(int,QString)");
        case 8: return QByteArrayLiteral("targetTemperature(QString)");
        case 9: return QByteArrayLiteral("setTargetTemperature(qreal,QString)");
        case 10: return QByteArrayLiteral("seatCooler(QString)");
        case 11: return QByteArrayLiteral("setSeatCooler(int,QString)");
        case 12: return QByteArrayLiteral("seatHeater(QString)");
        case 13: return QByteArrayLiteral("setSeatHeater(int,QString)");
        case 14: return QByteArrayLiteral("outsideTemperature(QString)");
        case 15: return QByteArrayLiteral("setOutsideTemperature(int,QString)");
        case 16: return QByteArrayLiteral("outsideTemperatureLabel(QString)");
        case 17: return QByteArrayLiteral("setOutsideTemperatureLabel(QString,QString)");
        case 18: return QByteArrayLiteral("isZoneSynchronizationEnabled(QString)");
        case 19: return QByteArrayLiteral("setZoneSynchronizationEnabled(bool,QString)");
        case 20: return QByteArrayLiteral("isDefrostEnabled(QString)");
        case 21: return QByteArrayLiteral("setDefrostEnabled(bool,QString)");
        case 22: return QByteArrayLiteral("recirculationMode(QString)");
        case 23: return QByteArrayLiteral("setRecirculationMode(QtIviVehicleFunctionsModule::RecirculationMode,QString)");
        case 24: return QByteArrayLiteral("isRecirculationEnabled(QString)");
        case 25: return QByteArrayLiteral("setRecirculationEnabled(bool,QString)");
        case 26: return QByteArrayLiteral("recirculationSensitivityLevel(QString)");
        case 27: return QByteArrayLiteral("setRecirculationSensitivityLevel(int,QString)");
        case 28: return QByteArrayLiteral("climateMode(QString)");
        case 29: return QByteArrayLiteral("setClimateMode(QtIviVehicleFunctionsModule::ClimateMode,QString)");
        case 30: return QByteArrayLiteral("automaticClimateFanIntensityLevel(QString)");
        case 31: return QByteArrayLiteral("setAutomaticClimateFanIntensityLevel(int,QString)");
        case 32: return QByteArrayLiteral("airflowDirections(QString)");
        case 33: return QByteArrayLiteral("setAirflowDirections(QtIviVehicleFunctionsModule::AirflowDirections,QString)");
        case 34: return QByteArrayLiteral("availableZones()");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("bool");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("bool");
        case 3: return QByteArrayLiteral("void");
        case 4: return QByteArrayLiteral("int");
        case 5: return QByteArrayLiteral("void");
        case 6: return QByteArrayLiteral("int");
        case 7: return QByteArrayLiteral("void");
        case 8: return QByteArrayLiteral("qreal");
        case 9: return QByteArrayLiteral("void");
        case 10: return QByteArrayLiteral("int");
        case 11: return QByteArrayLiteral("void");
        case 12: return QByteArrayLiteral("int");
        case 13: return QByteArrayLiteral("void");
        case 14: return QByteArrayLiteral("int");
        case 15: return QByteArrayLiteral("void");
        case 16: return QByteArrayLiteral("QString");
        case 17: return QByteArrayLiteral("void");
        case 18: return QByteArrayLiteral("bool");
        case 19: return QByteArrayLiteral("void");
        case 20: return QByteArrayLiteral("bool");
        case 21: return QByteArrayLiteral("void");
        case 22: return QByteArrayLiteral("QtIviVehicleFunctionsModule::RecirculationMode");
        case 23: return QByteArrayLiteral("void");
        case 24: return QByteArrayLiteral("bool");
        case 25: return QByteArrayLiteral("void");
        case 26: return QByteArrayLiteral("int");
        case 27: return QByteArrayLiteral("void");
        case 28: return QByteArrayLiteral("QtIviVehicleFunctionsModule::ClimateMode");
        case 29: return QByteArrayLiteral("void");
        case 30: return QByteArrayLiteral("int");
        case 31: return QByteArrayLiteral("void");
        case 32: return QByteArrayLiteral("QtIviVehicleFunctionsModule::AirflowDirections");
        case 33: return QByteArrayLiteral("void");
        case 34: return QByteArrayLiteral("QStringList");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"aa69730a3066b0300abc4ff5849ef878699a69db"}; }

    int m_enums[1];
    int m_properties[1];
    int m_signals[19];
    int m_methods[36];
    const QString m_name;
    int m_signalArgCount[18];
    const int* m_signalArgTypes[18];
    int m_methodArgCount[35];
    const int* m_methodArgTypes[35];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_QIVICLIMATECONTROL_SOURCE_H
