#ifndef REP_QIVIWINDOWCONTROL_SOURCE_H
#define REP_QIVIWINDOWCONTROL_SOURCE_H

// This is an autogenerated file.
// Do not edit this file, any changes made will be lost the next time it is generated.

#include <QtCore/qobject.h>
#include <QtCore/qdatastream.h>
#include <QtCore/qvariant.h>
#include <QtCore/qmetatype.h>

#include <QtRemoteObjects/qremoteobjectnode.h>
#include <QtRemoteObjects/qremoteobjectsource.h>

#include <QtIviVehicleFunctions/qtivivehiclefunctionsmodule.h>

class QIviWindowControlSource : public QObject
{
    Q_OBJECT
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_TYPE, "QIviWindowControl")
    Q_CLASSINFO(QCLASSINFO_REMOTEOBJECT_SIGNATURE, "bdd0d898255e49e523236f6988659880358bcf4c")

public:
    explicit QIviWindowControlSource(QObject *parent = nullptr) : QObject(parent)
    {
        qRegisterMetaType<QtIviVehicleFunctionsModule::BlindMode>();
        qRegisterMetaTypeStreamOperators<QtIviVehicleFunctionsModule::BlindMode>();
        qRegisterMetaType<QtIviVehicleFunctionsModule::WindowState>();
        qRegisterMetaTypeStreamOperators<QtIviVehicleFunctionsModule::WindowState>();
        qRegisterMetaType<QtIviVehicleFunctionsModule::HeaterMode>();
        qRegisterMetaTypeStreamOperators<QtIviVehicleFunctionsModule::HeaterMode>();

    }

public:
    ~QIviWindowControlSource() override = default;


Q_SIGNALS:
    void heaterModeChanged(QtIviVehicleFunctionsModule::HeaterMode heaterMode, const QString & zone);
    void heaterChanged(bool heater, const QString & zone);
    void stateChanged(QtIviVehicleFunctionsModule::WindowState state, const QString & zone);
    void blindModeChanged(QtIviVehicleFunctionsModule::BlindMode blindMode, const QString & zone);
    void blindStateChanged(QtIviVehicleFunctionsModule::WindowState blindState, const QString & zone);
    void pendingResultAvailable(quint64 id, bool isSuccess, const QVariant & value);

public Q_SLOTS:
    virtual QtIviVehicleFunctionsModule::HeaterMode heaterMode(const QString & zone) = 0;
    virtual void setHeaterMode(QtIviVehicleFunctionsModule::HeaterMode heaterMode, const QString & zone) = 0;
    virtual bool heater(const QString & zone) = 0;
    virtual QtIviVehicleFunctionsModule::WindowState state(const QString & zone) = 0;
    virtual QtIviVehicleFunctionsModule::BlindMode blindMode(const QString & zone) = 0;
    virtual void setBlindMode(QtIviVehicleFunctionsModule::BlindMode blindMode, const QString & zone) = 0;
    virtual QtIviVehicleFunctionsModule::WindowState blindState(const QString & zone) = 0;
    virtual QStringList availableZones() = 0;
    virtual QVariant open(const QString & zone) = 0;
    virtual QVariant close(const QString & zone) = 0;

private:
    friend class QT_PREPEND_NAMESPACE(QRemoteObjectNode);
};


class QIviWindowControlSimpleSource : public QIviWindowControlSource
{
    Q_OBJECT

public:
    explicit QIviWindowControlSimpleSource(QObject *parent = nullptr) : QIviWindowControlSource(parent)
    {
    }

public:
    ~QIviWindowControlSimpleSource() override = default;


private:
};


template <class ObjectType>
struct QIviWindowControlSourceAPI : public SourceApiMap
{
    QIviWindowControlSourceAPI(ObjectType *object, const QString &name = QLatin1String("QIviWindowControl"))
        : SourceApiMap(), m_name(name)
    {
        Q_UNUSED(object);
        m_enums[0] = 0;
        m_properties[0] = 0;
        m_signals[0] = 6;
        m_signals[1] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::heaterModeChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::HeaterMode,QString)>(0),m_signalArgCount+0,&m_signalArgTypes[0]);
        m_signals[2] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::heaterChanged, static_cast<void (QObject::*)(bool,QString)>(0),m_signalArgCount+1,&m_signalArgTypes[1]);
        m_signals[3] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::stateChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::WindowState,QString)>(0),m_signalArgCount+2,&m_signalArgTypes[2]);
        m_signals[4] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::blindModeChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::BlindMode,QString)>(0),m_signalArgCount+3,&m_signalArgTypes[3]);
        m_signals[5] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::blindStateChanged, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::WindowState,QString)>(0),m_signalArgCount+4,&m_signalArgTypes[4]);
        m_signals[6] = QtPrivate::qtro_signal_index<ObjectType>(&ObjectType::pendingResultAvailable, static_cast<void (QObject::*)(quint64,bool,QVariant)>(0),m_signalArgCount+5,&m_signalArgTypes[5]);
        m_methods[0] = 10;
        m_methods[1] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::heaterMode, static_cast<void (QObject::*)(QString)>(0),"heaterMode(QString)",m_methodArgCount+0,&m_methodArgTypes[0]);
        m_methods[2] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setHeaterMode, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::HeaterMode,QString)>(0),"setHeaterMode(QtIviVehicleFunctionsModule::HeaterMode,QString)",m_methodArgCount+1,&m_methodArgTypes[1]);
        m_methods[3] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::heater, static_cast<void (QObject::*)(QString)>(0),"heater(QString)",m_methodArgCount+2,&m_methodArgTypes[2]);
        m_methods[4] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::state, static_cast<void (QObject::*)(QString)>(0),"state(QString)",m_methodArgCount+3,&m_methodArgTypes[3]);
        m_methods[5] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::blindMode, static_cast<void (QObject::*)(QString)>(0),"blindMode(QString)",m_methodArgCount+4,&m_methodArgTypes[4]);
        m_methods[6] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::setBlindMode, static_cast<void (QObject::*)(QtIviVehicleFunctionsModule::BlindMode,QString)>(0),"setBlindMode(QtIviVehicleFunctionsModule::BlindMode,QString)",m_methodArgCount+5,&m_methodArgTypes[5]);
        m_methods[7] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::blindState, static_cast<void (QObject::*)(QString)>(0),"blindState(QString)",m_methodArgCount+6,&m_methodArgTypes[6]);
        m_methods[8] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::availableZones, static_cast<void (QObject::*)()>(0),"availableZones()",m_methodArgCount+7,&m_methodArgTypes[7]);
        m_methods[9] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::open, static_cast<void (QObject::*)(QString)>(0),"open(QString)",m_methodArgCount+8,&m_methodArgTypes[8]);
        m_methods[10] = QtPrivate::qtro_method_index<ObjectType>(&ObjectType::close, static_cast<void (QObject::*)(QString)>(0),"close(QString)",m_methodArgCount+9,&m_methodArgTypes[9]);
    }

    QString name() const override { return m_name; }
    QString typeName() const override { return QStringLiteral("QIviWindowControl"); }
    int enumCount() const override { return m_enums[0]; }
    int propertyCount() const override { return m_properties[0]; }
    int signalCount() const override { return m_signals[0]; }
    int methodCount() const override { return m_methods[0]; }
    int sourceEnumIndex(int index) const override
    {
        if (index < 0 || index >= m_enums[0])
            return -1;
        return m_enums[index+1];
    }
    int sourcePropertyIndex(int index) const override
    {
        if (index < 0 || index >= m_properties[0])
            return -1;
        return m_properties[index+1];
    }
    int sourceSignalIndex(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signals[index+1];
    }
    int sourceMethodIndex(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methods[index+1];
    }
    int signalParameterCount(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return -1;
        return m_signalArgCount[index];
    }
    int signalParameterType(int sigIndex, int paramIndex) const override
    {
        if (sigIndex < 0 || sigIndex >= m_signals[0] || paramIndex < 0 || paramIndex >= m_signalArgCount[sigIndex])
            return -1;
        return m_signalArgTypes[sigIndex][paramIndex];
    }
    int methodParameterCount(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return -1;
        return m_methodArgCount[index];
    }
    int methodParameterType(int methodIndex, int paramIndex) const override
    {
        if (methodIndex < 0 || methodIndex >= m_methods[0] || paramIndex < 0 || paramIndex >= m_methodArgCount[methodIndex])
            return -1;
        return m_methodArgTypes[methodIndex][paramIndex];
    }
    int propertyIndexFromSignal(int index) const override
    {
        Q_UNUSED(index);
        return -1;
    }
    int propertyRawIndexFromSignal(int index) const override
    {
        Q_UNUSED(index);
        return -1;
    }
    const QByteArray signalSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("heaterModeChanged(QtIviVehicleFunctionsModule::HeaterMode,QString)");
        case 1: return QByteArrayLiteral("heaterChanged(bool,QString)");
        case 2: return QByteArrayLiteral("stateChanged(QtIviVehicleFunctionsModule::WindowState,QString)");
        case 3: return QByteArrayLiteral("blindModeChanged(QtIviVehicleFunctionsModule::BlindMode,QString)");
        case 4: return QByteArrayLiteral("blindStateChanged(QtIviVehicleFunctionsModule::WindowState,QString)");
        case 5: return QByteArrayLiteral("pendingResultAvailable(quint64,bool,QVariant)");
        }
        return QByteArrayLiteral("");
    }
    QList<QByteArray> signalParameterNames(int index) const override
    {
        if (index < 0 || index >= m_signals[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_signals[index + 1]).parameterNames();
    }
    const QByteArray methodSignature(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("heaterMode(QString)");
        case 1: return QByteArrayLiteral("setHeaterMode(QtIviVehicleFunctionsModule::HeaterMode,QString)");
        case 2: return QByteArrayLiteral("heater(QString)");
        case 3: return QByteArrayLiteral("state(QString)");
        case 4: return QByteArrayLiteral("blindMode(QString)");
        case 5: return QByteArrayLiteral("setBlindMode(QtIviVehicleFunctionsModule::BlindMode,QString)");
        case 6: return QByteArrayLiteral("blindState(QString)");
        case 7: return QByteArrayLiteral("availableZones()");
        case 8: return QByteArrayLiteral("open(QString)");
        case 9: return QByteArrayLiteral("close(QString)");
        }
        return QByteArrayLiteral("");
    }
    QMetaMethod::MethodType methodType(int) const override
    {
        return QMetaMethod::Slot;
    }
    QList<QByteArray> methodParameterNames(int index) const override
    {
        if (index < 0 || index >= m_methods[0])
            return QList<QByteArray>();
        return ObjectType::staticMetaObject.method(m_methods[index + 1]).parameterNames();
    }
    const QByteArray typeName(int index) const override
    {
        switch (index) {
        case 0: return QByteArrayLiteral("QtIviVehicleFunctionsModule::HeaterMode");
        case 1: return QByteArrayLiteral("void");
        case 2: return QByteArrayLiteral("bool");
        case 3: return QByteArrayLiteral("QtIviVehicleFunctionsModule::WindowState");
        case 4: return QByteArrayLiteral("QtIviVehicleFunctionsModule::BlindMode");
        case 5: return QByteArrayLiteral("void");
        case 6: return QByteArrayLiteral("QtIviVehicleFunctionsModule::WindowState");
        case 7: return QByteArrayLiteral("QStringList");
        case 8: return QByteArrayLiteral("QVariant");
        case 9: return QByteArrayLiteral("QVariant");
        }
        return QByteArrayLiteral("");
    }
    QByteArray objectSignature() const override { return QByteArray{"bdd0d898255e49e523236f6988659880358bcf4c"}; }

    int m_enums[1];
    int m_properties[1];
    int m_signals[7];
    int m_methods[11];
    const QString m_name;
    int m_signalArgCount[6];
    const int* m_signalArgTypes[6];
    int m_methodArgCount[10];
    const int* m_methodArgTypes[10];
};

QT_BEGIN_NAMESPACE
QT_END_NAMESPACE


#endif // REP_QIVIWINDOWCONTROL_SOURCE_H
